package com.iver.andami.ui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import com.iver.andami.authentication.IAuthentication;

/**
 * Form to let the user log in the system. 
 * @author laura
 *
 */ 
public class LoginUI extends JDialog
{
	private JLabel usernameLabel;
	private JLabel passwordLabel;
	private JLabel serverURLLabel;
 
	private JTextField usernameField;
	private JPasswordField passwordField;
	private JTextField serverURLField;
 
	private JButton okButton;
	private JButton exitButton;
 
	private JPanel mainPanel;
	private JPanel labelsPanel;
	private JPanel textFieldsPanel;
	
	//private JPanel upperPanel;
	private JPanel buttonPanel;
 	
	IAuthentication authentication;
	
	public LoginUI(IAuthentication authentication )
	{
		Container container = getContentPane();
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
		
		usernameLabel = new JLabel( "Nombre: " );
		passwordLabel = new JLabel( "Clave : " );
		serverURLLabel = new JLabel( "Servidor: ");
		usernameField = new JTextField();
		passwordField = new JPasswordField();
		serverURLField = new JTextField();
		
		String server_text = (String)authentication.get("server_url");
		if(server_text != null){
			serverURLField.setText( server_text );
		}
 		
		labelsPanel = new JPanel();
		labelsPanel.setLayout(new GridLayout( 3, 1));
		textFieldsPanel = new JPanel();
		textFieldsPanel.setLayout( new GridLayout( 3, 1 ) );
		labelsPanel.add( usernameLabel );
		textFieldsPanel.add( usernameField );
		labelsPanel.add( passwordLabel );
		textFieldsPanel.add( passwordField );
		labelsPanel.add( serverURLLabel);
		textFieldsPanel.add( serverURLField);
 		
		buttonPanel = new JPanel();
		//buttonPanel.setLayout( new GridLayout( 1, 2 ) );
		okButton = new JButton( "OK" );
		okButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				OK();
			}
		});
		exitButton = new JButton( "Exit" );
		exitButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				Cancel();
			}
		});
 
		buttonPanel.add( okButton );
		buttonPanel.add( exitButton );
		
		container.add( mainPanel, BorderLayout.CENTER );
		mainPanel.add(labelsPanel, BorderLayout.WEST );
		mainPanel.add(textFieldsPanel, BorderLayout.EAST);
		mainPanel.add( buttonPanel, BorderLayout.SOUTH );

		this.authentication = authentication;
		this.setBounds(400,400,this.getWidth(),this.getHeight());
		this.setTitle( "Login" );
		this.setModal(true);
		this.setSize( 400, 200);
		this.setResizable( false );
		pack();
		setVisible( true );
	}
 
	public void OK()
	{
		authentication.put("user", (String)usernameField.getText());
		authentication.put("pwd", new String(passwordField.getPassword()));
		authentication.put("server", (String)serverURLField.getText());
		this.dispose();
	}
	public void Cancel()
	{
		authentication.put("user", "");
		authentication.put("pwd", "");
		dispose();
		System.exit( 0 );		
	}
	
}
