/*
 * Created on 05-may-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import java.awt.Component;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.FileWriter;

import javax.swing.JFileChooser;
import javax.swing.KeyStroke;

import org.apache.log4j.Logger;
import org.exolab.castor.xml.Marshaller;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.gui.layout.FLayoutZooms;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.LayoutKeyEvent;
import com.iver.utiles.GenericFileFilter;


/**
 * Extensin para controlar las operaciones basicas sobre el Layout.
 *
 * @author Vicente Caballero Navarro
 */
public class LayoutControls extends Extension {
	private static Logger logger = Logger.getLogger(LayoutControls.class.getName());
	private Layout layout = null;

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String s) {
		layout = (Layout) PluginServices.getMDIManager().getActiveWindow();

		FLayoutZooms zooms = new FLayoutZooms(layout);
		logger.debug("Comand : " + s);

		if (s.equals("PAN")) {
			layout.setTool(Layout.PAN);
		} else if (s.equals("ZOOM_IN")) {
			layout.setTool(Layout.ZOOM_MAS);
		} else if (s.equals("ZOOM_OUT")) {
			layout.setTool(Layout.ZOOM_MENOS);
		} else if (s.equals("CONFIG")) {
			layout.showFConfig();
			layout.fullRect();
		} else if (s.equals("FULL")) {
			layout.fullRect();
		} else if (s.equals("REALZOOM")) {
			zooms.realZoom();
		} else if (s.equals("ZOOMOUT")) {
			zooms.zoomOut();
		} else if (s.equals("ZOOMIN")) {
			zooms.zoomIn();
		} else if (s.equals("ZOOMSELECT")) {
			zooms.zoomSelect();
		} else if (s.equals("PDF")){
			layout.layoutToPDF();
		} else if (s.equals("PS")){
			layout.layoutToPS();
		} else if (s.equals("SAVETEMPLATE")){
			saveLayout();
		}
	}
	private void saveLayout() {
    	layout = (Layout) PluginServices.getMDIManager().getActiveWindow();
		JFileChooser jfc = new JFileChooser();
		jfc.addChoosableFileFilter(new GenericFileFilter("gvt",
				PluginServices.getText(this, "plantilla")));

		if (jfc.showSaveDialog((Component) PluginServices.getMainFrame()) == JFileChooser.APPROVE_OPTION) {
			File file=jfc.getSelectedFile();
			if (!(file.getPath().endsWith(".gvt") || file.getPath().endsWith(".GVT"))){
				file=new File(file.getPath()+".gvt");
			}
			try {
				FileWriter writer = new FileWriter(file.getAbsolutePath());
				Marshaller m = new Marshaller(writer);
				m.setEncoding("ISO-8859-1");
				m.marshal(layout.getXMLEntity().getXmlTag());
			} catch (Exception e) {
				NotificationManager.addError(PluginServices.getText(this, "Error_guardando_la_plantilla"), e);
			}
		}
	}
	/**
	 * @see com.iver.mdiApp.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		IWindow f = PluginServices.getMDIManager().getActiveWindow();

		if (f == null) {
			return false;
		}

		if (f instanceof Layout) {
		//	Layout layout = (Layout) f;

			return true; //layout.m_Display.getMapControl().getMapContext().getLayers().layerCount() > 0;
		} else {
			return false;
		}
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		return true;
	}

	/**
	 * Devuelve el Layout sobre el que se opera.
	 *
	 * @return Layout.
	 */
	public Layout getLayout() {
		return layout;
	}
}
