/*
 * Created on 17-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;

import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.event.PrintJobAdapter;
import javax.print.event.PrintJobEvent;
import javax.print.event.PrintJobListener;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.gui.layout.Attributes;
import com.iver.cit.gvsig.gui.layout.FLayoutUtilities;
import com.iver.cit.gvsig.gui.layout.Layout;


/**
 * Extensin desde la que se imprime.
 *
 * @author Vicente Caballero Navarro
 */
public class Print extends Extension implements Printable {
	public static PrinterJob printerJob = PrinterJob.getPrinterJob();
	private static Layout l = null;
	//private Paper paper;
	Rectangle2D.Double aux = null;
	private int veces = 0;
	private PrintService[] m_cachePrintServices = null;
	private PrintService m_cachePrintService = null;

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String s) {
		l = (Layout) PluginServices.getMDIManager().getActiveWindow();

		//PageFormat format = printerJob.defaultPage(); //new PageFormat();
		//paper = format.getPaper();

		//double margin = 72.0 / 25.4 * 5.0;
		try {
			PluginServices.backgroundExecution(new Runnable() {
					public void run() {
						if (l.getAtributes().getType() == Attributes.CUSTOM) {
							l.showPrintDialog(printerJob);
						} else {
							l.showPrintDialog(null);
						}
					}
				});

			//Thread.sleep(10000);
		} catch (Exception e) {
			System.out.println("Excepcin al abrir el dilogo de impresin: " +
				e);
		}
	}
	public void setLayout(Layout l){
		this.l=l;
	}
	/**
	 * Se dibuja sobre el graphics el Layout.
	 *
	 * @param g2 graphics sobre el que se dibuja.
	 */
	public void drawShapes(Graphics2D g2) {
		///double w = paper.getWidth();
		//System.out.println("w " + w);
		///double h = paper.getHeight();
		//System.out.println("h " + h);
		//g2.translate(-l.getRect().x, -l.getRect().y);
		l.drawLayoutPrint(g2);

		// System.out.println("drawShapes = "+g2.getTransform().getScaleX());
		//g2.translate(l.getRect().x, l.getRect().y);
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		IWindow f = PluginServices.getMDIManager().getActiveWindow();

		if (f == null) {
			return false;
		}

		return (f instanceof Layout);
	}

	/**
	 * @see com.iver.mdiApp.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		Layout f = (Layout) PluginServices.getMDIManager().getActiveWindow();

		if (f == null) {
			return false;
		}

		return true;
	}

	/* (non-Javadoc)
	 * @see java.awt.print.Printable#print(java.awt.Graphics, java.awt.print.PageFormat, int)
	 */
	public int print(Graphics g, PageFormat format, int pi)
		throws PrinterException {
		if (pi >= 1) {
			return Printable.NO_SUCH_PAGE;
		}

		System.err.println("Clip 0 = " + g.getClip());

		Graphics2D g2d = (Graphics2D) g;

		double x = format.getImageableX();
		double y = format.getImageableY();
		double w = format.getImageableWidth();
		double h = format.getImageableHeight();

		//System.err.println("Orientacin en Print: " + format.getOrientation());
		System.out.println("print:(" + x + "," + y + "," + w + "," + h + ")");
		System.err.println("Clip 1 = " + g2d.getClip());

		AffineTransform at = g2d.getTransform();
		g2d.translate(0, 0);
		l.obtainRect(true);

		//LWSAffineTransform at = g2d.getTransform();
		g2d.scale((double) 72 / (double) (Attributes.DPI),
			(double) 72 / (double) (Attributes.DPI));
		System.err.println("Clip 2 =" + g2d.getClip());

		if (l.getAtributes().isMargin()) {
			g2d.setClip((int) (l.getRect().getMinX() +
				FLayoutUtilities.fromSheetDistance(l.getAtributes().m_area[2],
					l.getAT())),
				(int) (l.getRect().getMinY() +
				FLayoutUtilities.fromSheetDistance(l.getAtributes().m_area[0],
					l.getAT())),
				(int) (l.getRect().getWidth() -
				FLayoutUtilities.fromSheetDistance(l.getAtributes().m_area[2] +
					l.getAtributes().m_area[3], l.getAT())),
				(int) (l.getRect().getHeight() -
				FLayoutUtilities.fromSheetDistance(l.getAtributes().m_area[0] +
					l.getAtributes().m_area[1], l.getAT())));
		} else {
			/*
			   Rectangle rec=(Rectangle)g2d.getClipBounds();
			   Rectangle2D.Double rec2d=new Rectangle2D.Double();
			   rec2d.setRect(rec.x,rec.y,l.getRect().width,rec.getHeight());
			   g2d.setClip((int)rec2d.x,(int)rec2d.y,(int)rec2d.width,(int)rec2d.height);
			 */
			/* g2d.setClip((int) l.getRect().getMinX(),
			   (int) l.getRect().getMinY(), (int) l.getRect().getWidth(),
			   (int) l.getRect().getHeight()); */
		}

		veces++;
		System.out.println("veces = " + veces);

		drawShapes(g2d);
		g2d.setTransform(at);

		return Printable.PAGE_EXISTS;
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/**
	 * Abre un dilogo para imprimir.
	 *
	 * @param layout Layout a imprimir.
	 */
	public void OpenDialogToPrint(Layout layout) {
		l = layout;

		//PageFormat format = printerJob.defaultPage(); //new PageFormat();
		//paper = format.getPaper();

		try {
			if (layout.getAtributes().getType() == Attributes.CUSTOM) {
				layout.showPrintDialog(printerJob);
			} else {
				layout.showPrintDialog(null);
			}
		} catch (Exception e) {
			System.out.println("Excepcin al abrir el dilogo de impresin: " +
				e);
			e.printStackTrace();
		}
	}

	/**
	 * Imprime el Layout que se pasa como parmetro.
	 *
	 * @param layout Layout a imprimir.
	 */
	public void printLayout(Layout layout) {
		l = layout;

		try {
			printerJob.setPrintable((Printable) PluginServices.getExtension(
					com.iver.cit.gvsig.Print.class));

			//Actualizar attributes
			PrintRequestAttributeSet att = layout.getAtributes()
												 .toPrintAttributes();
			DocFlavor flavor = DocFlavor.SERVICE_FORMATTED.PRINTABLE;

			if (m_cachePrintServices == null) {
				m_cachePrintServices = PrintServiceLookup.lookupPrintServices(flavor,
						null);
			}

			PrintService defaultService = null;

			if (m_cachePrintService == null) {
				defaultService = PrintServiceLookup.lookupDefaultPrintService();
			}

			if (m_cachePrintService == null) {
				m_cachePrintService = ServiceUI.printDialog(null, 200, 200,
						m_cachePrintServices, defaultService, flavor, att);
			}

			if (m_cachePrintService != null) {
				DocPrintJob jobNuevo = m_cachePrintService.createPrintJob();
				PrintJobListener pjlistener = new PrintJobAdapter() {
						public void printDataTransferCompleted(PrintJobEvent e) {
							System.out.println("Fin de impresin");
						}
					};

				jobNuevo.addPrintJobListener(pjlistener);

				Doc doc = new SimpleDoc((Printable) PluginServices.getExtension(
							com.iver.cit.gvsig.Print.class), flavor, null);
				jobNuevo.print(doc, att);
			}
		} catch (PrintException pe) {
			pe.printStackTrace();
		}
	}
}
