/*
 * Created on 23-abr-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui;

import java.awt.BorderLayout;
import java.io.File;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.TreeSet;

import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.filechooser.FileFilter;

import com.hardcode.driverManager.Driver;
import com.hardcode.driverManager.DriverLoadException;
import com.hardcode.gdbms.engine.data.driver.FileDriver;
import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.drivers.RasterDriver;
import com.iver.cit.gvsig.fmap.drivers.VectorialFileDriver;
import com.iver.cit.gvsig.fmap.layers.LayerFactory;
import com.iver.cit.gvsig.gui.panels.ProjChooserPanel;
import com.iver.utiles.listManager.ListManagerListener;
/**
 * Dilogo para cargar las dieferentes capas a la vista.
 *
 * @author Vicente Caballero Navarro
 */
public class FileOpenDialog extends JPanel{
	// TODO LWS los m_Files ... tendran que ser GeoFiles (Projected y dems)?	
	private static String lastPath = null;
	private static DriverFileFilter lastFileFilter = null;
    private ArrayList m_Files;
    private javax.swing.JPanel jPanel2 = null;
    private DefaultListModel m_lstModel;
    private JFileChooser fileChooser;
    private Class[] driverClasses;
    private String title = PluginServices.getText(this,"Capas");

	private ProjChooserPanel jPanelProj = null;
	//private JLabel jLabel = null;
	//private JComboBox jCboProjections = null;
	private ListManagerSkin listManagerDemoSkin = null;
    private boolean proj;
    public FileOpenDialog(Class[] driverClasses) {
        init(driverClasses, true);
    }

    /**
     * @param driverClasses2
     * @param b
     */
    private void init(Class[] driverClasses, boolean proj) {
        this.proj = proj;

    	initialize();

        m_Files = new ArrayList();

        this.driverClasses = driverClasses;

        // Cada vez que se abre, se borran las capas que pudiera haber.
        m_lstModel = new DefaultListModel();
    }

    /**
     * Creates a new FOpenDialog object.
     *
     * @param view Vista que vamos a refrescar
     * @param mapControl MapControl que recibe la capa (te puede interesar
     *        aadirla al principal o al Overview.
     */
    public FileOpenDialog(Class[] driverClasses, boolean proj) {
        init(driverClasses, proj);
    }

    public FileOpenDialog(Class[] driverClasses, boolean proj, String title) {
    	this.title= title;
        init(driverClasses, proj);
    }

    /**
     * This method initializes this
     */
    private void initialize() {
        this.setLayout(new BorderLayout());
        this.setSize(514, 280);
        this.setLayout(null);
//        this.setBorder(javax.swing.BorderFactory.createBevelBorder(
  //              javax.swing.border.BevelBorder.RAISED));
        this.add(getJPanel2(), null);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public File[] getFiles() {
        MyFile[] files = (MyFile[]) getListManagerDemoSkin().getListManager().getListModel().getObjects().toArray(new MyFile[0]);
        File[] ret = new File[files.length];
        int pos=files.length-1;
        for (int i=0; i < files.length; i++){
        	ret[pos] = files[i].f;
        	pos--;
        }
        return ret;
    }
    public boolean accept(File f){
    	return fileChooser.getFileFilter().accept(f);
    }
    /**
     * This method initializes jPanel2
     *
     * @return javax.swing.JPanel
     */
    private javax.swing.JPanel getJPanel2() {
        if (jPanel2 == null) {
            javax.swing.border.TitledBorder titledBorder1 = javax.swing.BorderFactory.createTitledBorder(null,
            		PluginServices.getText(this,"Seleccionar_fichero"),
                    javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                    javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null);
            jPanel2 = new javax.swing.JPanel();
            jPanel2.setLayout(null);
            jPanel2.setBorder(titledBorder1);
            jPanel2.setPreferredSize(new java.awt.Dimension(380,200));
            jPanel2.setBounds(2, 2, 506, 472);
            titledBorder1.setTitle(this.title);
            if (proj) {
                jPanel2.add(getJPanelProj(), null);
            }
            jPanel2.add(getListManagerDemoSkin(), null);
        }

        return jPanel2;
    }

    public String[] getDriverNames(){
        MyFile[] files = (MyFile[]) getListManagerDemoSkin().getListManager().getListModel().getObjects().toArray(new MyFile[0]);
        String[] ret = new String[files.length];
        int pos=files.length-1;

        for (int i=0; i < files.length; i++)
        {
        	ret[pos] = files[i].getDriverName();
        	pos--;
        }
        return ret;

    	// return ((DriverFileFilter) fileChooser.getFileFilter()).getDescription();
    }

    public class DriverFileFilter extends FileFilter{

		private Driver driver;

		public DriverFileFilter(String driverName) throws DriverLoadException{
			driver = LayerFactory.getDM().getDriver(driverName);
		}

		/**
		 * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
		 */
		public boolean accept(File f) {
			if (f.isDirectory()) return true;
			if (driver instanceof VectorialFileDriver){
				return ((VectorialFileDriver) driver).accept(f);
			}else if (driver instanceof FileDriver){
				return ((FileDriver) driver).fileAccepted(f);
			}else if (driver instanceof RasterDriver){
				return ((RasterDriver) driver).fileAccepted(f);
			}else{
				throw new RuntimeException("Tipo no reconocido");
			}
		}

		/**
		 * @see javax.swing.filechooser.FileFilter#getDescription()
		 */
		public String getDescription() {
			return ((Driver) driver).getName();
		}
	}

	public void setDriverClasses(Class[] driverClasses) {
		this.driverClasses = driverClasses;
	}
	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private ProjChooserPanel getJPanelProj() {
		if (jPanelProj == null) {
			jPanelProj = new ProjChooserPanel(FOpenDialog.getLastProjection());
			jPanelProj.setBounds(11, 400, 448, 35);
			jPanelProj.setPreferredSize(new java.awt.Dimension(448,35));
			jPanelProj.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
			        if (jPanelProj.isOkPressed()) {
			        	FOpenDialog.setLastProjection(jPanelProj.getCurProj());
			        }
				}
			});
/*			jPanel = new JLabel();
			jPanel.setBounds(11, 214, 448, 37);
			jLabel.setText("Seleccione la proyeccin:");
			jPanel.add(jLabel, null);
			jPanel.add(getJCboProjections(), null);*/
		}
		return jPanelProj;
	}
	/*
	 * This method initializes jComboBox
	 *
	 * @return javax.swing.JComboBox
	 * /
	private JComboBox getJCboProjections() {
		if (jCboProjections == null) {
			Iterator it = ProjectionPool.iterator();
			Vector vector = new Vector();
			int selected = -1;
			int i=0;
			while (it.hasNext())
			{
				IProjection auxP =(IProjection) it.next();
				if (auxP == FOpenDialog.getLastProjection())
						selected = i;
				vector.add(auxP.getAbrev());
				i++;
			}
			DefaultComboBoxModel cModel = new DefaultComboBoxModel(vector);
			cModel.setSelectedItem(vector.get(selected));
			jCboProjections = new JComboBox(cModel);
			jCboProjections.setPreferredSize(new java.awt.Dimension(124,19));
			jCboProjections.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					String strProj = (String) jCboProjections.getSelectedItem();
					FOpenDialog.setLastProjection(ProjectionPool.get(strProj));
				}
			});
		}
		return jCboProjections;
	}*/

	public class MyFile {
		private File f;
		private String driverName;

		public MyFile(File f, String driverName){
			this.f = f;
			this.driverName = driverName;
		}

		public String toString(){
			return f.getName();
		}
		public String getDriverName(){
			return driverName;
		}

	}

	/**
	 * This method initializes listManagerDemoSkin
	 *
	 * @return com.iver.utiles.listManager.ListManagerDemoSkin
	 */
	private ListManagerSkin getListManagerDemoSkin() {
		if (listManagerDemoSkin == null) {
			listManagerDemoSkin = new ListManagerSkin(false);
			listManagerDemoSkin.setBounds(11, 21, 491, 363);
			listManagerDemoSkin.getListManager().setListener(new ListManagerListener() {
				public Object[] addObjects() {
				    TreeSet filters = new TreeSet(new Comparator() {
                        public int compare(Object o1, Object o2) {
                            DriverFileFilter dff1 = (DriverFileFilter) o1;
                            DriverFileFilter dff2 = (DriverFileFilter) o2;

                            return dff1.driver.getName().compareTo(dff2.driver.getName());
                        }
                    });
                    fileChooser = new JFileChooser(lastPath);
                    fileChooser.setMultiSelectionEnabled(true);
                    fileChooser.setAcceptAllFileFilterUsed(false);

                    try {
                        boolean last = false;
						String[] driverNames = LayerFactory.getDM().getDriverNames();
						DriverFileFilter defaultFileFilter = null;
                        DriverFileFilter auxF;
						for (int i = 0; i < driverNames.length; i++) {
							System.err.println("DRIVER "+i+" : "+driverNames[i]);
							boolean is = false;
							for (int j = 0; j < driverClasses.length; j++) {
								if (i == 0) System.err.println("DRIVER CLASS "+j+" : "+driverClasses[j].toString());
								if (LayerFactory.getDM().isA(driverNames[i], driverClasses[j]))
									is = true;
							}
							if (is){
							    auxF = new DriverFileFilter(driverNames[i]);
								filters.add(auxF);
								if (driverNames[i].indexOf("shp") != -1) {
								    defaultFileFilter = auxF;
								}
                                if (lastFileFilter != null) {
                                    if (driverNames[i].equals(lastFileFilter.driver.getName())){
                                        last = true;
                                    }
                                }
							}
						}
                        DriverFileFilter def = (DriverFileFilter) fileChooser.getFileFilter();
                        if (last) {
                            def = lastFileFilter;
                        } else {
                            if (lastFileFilter != null){
                                if (filters.contains(lastFileFilter)) {
                                    def = defaultFileFilter;
                                }
                            }
                        }
                        Iterator i = filters.iterator();
                        while (i.hasNext()) {
                            DriverFileFilter element = (DriverFileFilter) i.next();
                            if (def != null){
                                if (!element.driver.getName().equals(def.driver.getName())){
                                    fileChooser.addChoosableFileFilter(element);
                                }
                            } else {
                                fileChooser.addChoosableFileFilter(element);
                            }
                        }
                        if (def != null){
                            fileChooser.setFileFilter(def);
                        }

					} catch (DriverLoadException e1) {
						NotificationManager.addError("No se pudo acceder a los drivers", e1);
					}

					int result = fileChooser.showOpenDialog(FileOpenDialog.this);

                    File[] newFiles = null;
                    MyFile[] toAdd;
                    if (result == JFileChooser.APPROVE_OPTION) {
                        lastFileFilter = (DriverFileFilter) fileChooser.getFileFilter();
                        lastPath = fileChooser.getCurrentDirectory().getAbsolutePath();
                		newFiles = fileChooser.getSelectedFiles();
                		toAdd = new MyFile[newFiles.length];
                		for (int ind=0; ind < newFiles.length; ind++)
                		{
                		    String driverName = ((DriverFileFilter) fileChooser.getFileFilter()).getDescription();
                		    toAdd[ind] = new MyFile(newFiles[ind], driverName);
                		}


                		return toAdd;
                    }
                    else
                    	return new Object[0];

                    // DefaultListModel lstModel = new DefaultListModel();
/*
                    for (int iFile = 0; iFile < newFiles.length;
                            iFile++) {
                    	File theFile = newFiles[iFile];
                    	String absolutePath = theFile.getAbsolutePath();
                    	lastPath = theFile.getParent();
                    	// Miramos por si es un ecwp:
                    	int test = absolutePath.indexOf("ecwp:");
                    	if (test == -1)
                    		m_lstModel.addElement(absolutePath);
                    	else
                    		m_lstModel.addElement(absolutePath.substring(test));
                    }

                    getJListLayers().setModel(m_lstModel);*/

                }

				public Object getProperties(Object selected) {
					return null;
				}
			});
		}
		return listManagerDemoSkin;
	}
   }  //  @jve:decl-index=0:visual-constraint="10,10"
 //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
//  @jve:visual-info  decl-index=0 visual-constraint="10,10"
