/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id$
 * $Log$
 * Revision 1.5  2006/08/29 07:56:27  cesar
 * Rename the *View* family of classes to *Window* (ie: SingletonView to SingletonWindow, ViewInfo to WindowInfo, etc)
 *
 * Revision 1.4  2006/06/08 07:57:37  caballero
 * zoom a un raster sobre el Layout
 *
 * Revision 1.3  2006/04/10 06:38:06  caballero
 * FFrameTable
 *
 * Revision 1.2  2006/01/18 15:15:08  caballero
 * eliminar cdigo no usado
 *
 * Revision 1.1  2006/01/12 12:32:12  caballero
 * box
 *
 *
 */

package com.iver.cit.gvsig.gui.layout.fframes.dialogs;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameTable;

public class FFrameBoxDialog extends JPanel implements IFFrameDialog{

	private JPanel jPanel = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JTextField txtNumColumns = null;
	private JTextField txtNumRows = null;
	private JButton bOk = null;
	private JButton bCancel = null;
	private Rectangle2D rect = new Rectangle2D.Double();
	private FFrameTable fframebox;
	private Layout m_layout;
	private boolean isAcepted = false;
	private JPanel pBox = null;
	private FFrameTable thefframebox;
	private JPRotation pRotation;
	/**
	 * This is the default constructor
	 *
	 * @param layout Referencia al Layout.
	 * @param fframe Referencia al fframe del cajetn.
	 */
	public FFrameBoxDialog(Layout layout, FFrameTable fframe) {
		super();
		fframebox = fframe;
		thefframebox=(FFrameTable)fframebox.cloneFFrame(layout);
		m_layout = layout;
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setLayout(null);
		this.setSize(518, 158);
		this.add(getJPanel(), null);
		this.add(getPRotation(),null);
		this.add(getBOk(), null);
		this.add(getBCancel(), null);
		getPRotation().setRotation(fframebox.getRotation());
	}

	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(7,32,112,19));
			jLabel1.setText(PluginServices.getText(this,"num_filas"));
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(7,8,112,19));
			jLabel.setText(PluginServices.getText(this,"num_columnas"));
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.setPreferredSize(new java.awt.Dimension(340,130));
			jPanel.setBounds(new java.awt.Rectangle(12,9,344,93));
			jPanel.add(jLabel, null);
			jPanel.add(jLabel1, null);
			jPanel.add(getTxtNumColumns(), null);
			jPanel.add(getTxtNumRows(), null);
			jPanel.add(getPBox(), null);

		}
		return jPanel;
	}

	/**
	 * This method initializes txtNumColumns
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtNumColumns() {
		if (txtNumColumns == null) {
			txtNumColumns = new JTextField();
			txtNumColumns.setText(String.valueOf(fframebox.getNumColumns()));
			txtNumColumns.setBounds(new java.awt.Rectangle(124,8,35,19));
			txtNumColumns.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyReleased(java.awt.event.KeyEvent e) {
					if (getTxtNumColumns().getText().equals("") || getTxtNumColumns().getText().equals("0"))return;
					thefframebox.setNumColumns(Integer.parseInt(getTxtNumColumns().getText()));
					getPBox().repaint();
				}
			});
		}
		return txtNumColumns;
	}

	/**
	 * This method initializes txtNumRows
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtNumRows() {
		if (txtNumRows == null) {
			txtNumRows = new JTextField();
			txtNumRows.setText(String.valueOf(fframebox.getNumRows()));
			txtNumRows.setBounds(new java.awt.Rectangle(124,32,35,19));
			txtNumRows.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyReleased(java.awt.event.KeyEvent e) {
					if (getTxtNumRows().getText().equals("") || getTxtNumRows().getText().equals("0"))return;
					thefframebox.setNumRows(Integer.parseInt(getTxtNumRows().getText()));
					getPBox().repaint();
				}
			});
		}
		return txtNumRows;
	}

	/**
	 * This method initializes bOk
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getBOk() {
		if (bOk == null) {
			bOk = new JButton();
			bOk.setText(PluginServices.getText(this,"aceptar"));
			bOk.setBounds(new java.awt.Rectangle(40,116,78,26));
			bOk.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					fframebox.setNumColumns(Integer.parseInt(getTxtNumColumns().getText()));
					fframebox.setNumRows(Integer.parseInt(getTxtNumRows().getText()));
					fframebox.setRotation(getPRotation().getRotation());
					Rectangle2D r=fframebox.getBoundBox();
			        fframebox.calculateTable(r);
					PluginServices.getMDIManager().closeWindow(FFrameBoxDialog.this);
					m_layout.refresh();
					isAcepted = true;
				}
			});
		}
		return bOk;
	}

	/**
	 * This method initializes bCancel
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getBCancel() {
		if (bCancel == null) {
			bCancel = new JButton();
			bCancel.setText(PluginServices.getText(this,"cancelar"));
			bCancel.setBounds(new java.awt.Rectangle(242,116,84,26));
			bCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					PluginServices.getMDIManager().closeWindow(FFrameBoxDialog.this);
				}
			});
		}
		return bCancel;
	}

	public void setRectangle(Rectangle2D r) {
		rect.setRect(r);
	}

	public WindowInfo getWindowInfo() {
		WindowInfo m_viewinfo = new WindowInfo(WindowInfo.MODALDIALOG);
		m_viewinfo.setTitle(PluginServices.getText(this,
				"propiedades_cajetin"));

		return m_viewinfo;
	}

	public boolean getIsAcepted() {
		return isAcepted;
	}

	/**
	 * This method initializes jPanel1
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getPBox() {
		if (pBox == null) {
			pBox = new PanelBox();
			pBox.setBackground(java.awt.Color.white);
			pBox.setSize(new java.awt.Dimension(165,75));
			pBox.setLocation(new java.awt.Point(168,8));
			pBox.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					///Rectangle2D r = new Rectangle2D.Double(5, 5, 155, 65);
				}
			});
		}
		return pBox;
	}
	/**
	 * This method initializes pRotation
	 *
	 * @return javax.swing.JPanel
	 */
	private JPRotation getPRotation() {
		if (pRotation == null) {
			pRotation = new JPRotation();
			pRotation.setBounds(373, 14, 120, 120);
		}
		return pRotation;
	}
	class PanelBox extends JPanel{
		protected void paintComponent(Graphics g) {
			super.paintComponent(g);
			Rectangle2D r=new Rectangle2D.Double(5,5,155,65);
			thefframebox.drawBox(r,(Graphics2D)g);
		}

	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
