/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/* CVS MESSAGES:
*
* $Id: ViewPage.java,v 1.4 2006/08/29 07:21:08 cesar Exp $
* $Log: ViewPage.java,v $
* Revision 1.4  2006/08/29 07:21:08  cesar
* Rename com.iver.cit.gvsig.fmap.Fmap class to com.iver.cit.gvsig.fmap.MapContext
*
* Revision 1.3  2006/08/22 12:30:59  jaume
* *** empty log message ***
*
* Revision 1.2  2006/08/22 07:36:04  jaume
* *** empty log message ***
*
* Revision 1.1  2006/08/04 11:41:05  caballero
* poder especificar el zoom a aplicar en las vistas
*
* Revision 1.3  2006/07/31 10:02:31  jaume
* *** empty log message ***
*
* Revision 1.2  2006/06/13 07:43:08  fjp
* Ajustes sobre los cuadros de dialogos de preferencias
*
* Revision 1.1  2006/06/12 16:04:28  caballero
* Preferencias
*
* Revision 1.11  2006/06/06 10:26:31  jaume
* *** empty log message ***
*
* Revision 1.10  2006/06/05 17:07:17  jaume
* *** empty log message ***
*
* Revision 1.9  2006/06/05 17:00:44  jaume
* *** empty log message ***
*
* Revision 1.8  2006/06/05 16:57:59  jaume
* *** empty log message ***
*
* Revision 1.7  2006/06/05 14:45:06  jaume
* *** empty log message ***
*
* Revision 1.6  2006/06/05 11:00:09  jaume
* *** empty log message ***
*
* Revision 1.5  2006/06/05 10:39:02  jaume
* *** empty log message ***
*
* Revision 1.4  2006/06/05 10:13:40  jaume
* *** empty log message ***
*
* Revision 1.3  2006/06/05 10:06:08  jaume
* *** empty log message ***
*
* Revision 1.2  2006/06/05 09:51:56  jaume
* *** empty log message ***
*
* Revision 1.1  2006/06/02 10:50:18  jaume
* *** empty log message ***
*
*
*/
package com.iver.cit.gvsig.gui.preferencespage;

import java.util.prefs.Preferences;

import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.iver.andami.PluginServices;
import com.iver.andami.preferences.AbstractPreferencePage;
import com.iver.andami.preferences.StoreException;
import com.iver.cit.gvsig.fmap.MapContext;

public class ViewPage extends AbstractPreferencePage {
	private static Preferences prefs = Preferences.userRoot().node( "gvsig.options.view" );
	private JTextField txtZoomInFactor;
	private JTextField txtZoomOutFactor;
	protected String id;
	private ImageIcon icon;
	private boolean changed = false;

	public ViewPage() {
		super();
		id = this.getClass().getName();
		icon = new ImageIcon(this.getClass().getClassLoader().getResource("images/Vista.png"));
		// zoom in factor
		addComponent(PluginServices.getText(this, "zoom_in_factor") + ":",
			txtZoomInFactor = new JTextField("", 15));
		// zoom out factor
		addComponent(PluginServices.getText(this, "zoom_out_factor") + ":",
			txtZoomOutFactor = new JTextField("", 15));
	}

	public void initializeValues() {
		double zoomInFactor = prefs.getDouble("factor.zoom_in",MapContext.ZOOMINFACTOR);
		double zoomOutFactor = prefs.getDouble("factor.zoom_out",MapContext.ZOOMOUTFACTOR);
		txtZoomInFactor.setText(String.valueOf(zoomInFactor));
		txtZoomOutFactor.setText(String.valueOf(zoomOutFactor));
		MapContext.ZOOMINFACTOR=zoomInFactor;
		MapContext.ZOOMOUTFACTOR=zoomOutFactor;
	}

	public String getID() {
		return id;
	}

	public String getTitle() {
		return PluginServices.getText(this, "Vista");
	}

	public JPanel getPanel() {
		return this;
	}

	public void storeValues() throws StoreException {
		double zif;
		double zof;
		try{
			zif=Double.parseDouble(txtZoomInFactor.getText());
			zof=Double.parseDouble(txtZoomOutFactor.getText());
		}catch (Exception e) {
			throw new StoreException(PluginServices.getText(this,"factor_zoom_incorrecto"));
		}
		prefs.putDouble("factor.zoom_in", zif);
		prefs.putDouble("factor.zoom_out", zof);
		MapContext.ZOOMINFACTOR=zif;
		MapContext.ZOOMOUTFACTOR=zof;

	}


	public void initializeDefaults() {
		txtZoomInFactor.setText(String.valueOf(MapContext.ZOOMINFACTOR));
		txtZoomOutFactor.setText(String.valueOf(MapContext.ZOOMOUTFACTOR));
	}

	public ImageIcon getIcon() {
		return icon;
	}

	public boolean isValueChanged() {
		return super.hasChanged();
	}

	public void setChangesApplied() {
		setChanged(false);
	}
}
