/*
 * Created on 01-jun-2004
 *
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.thememanager.legendmanager.panels;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.sql.Types;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JPanel;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.ProjectExtension;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.FShape;
import com.iver.cit.gvsig.fmap.core.v02.FConstant;
import com.iver.cit.gvsig.fmap.core.v02.FSymbol;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.SelectableDataSource;
import com.iver.cit.gvsig.fmap.layers.layerOperations.ClassifiableVectorial;
import com.iver.cit.gvsig.fmap.rendering.Legend;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;
import com.iver.cit.gvsig.gui.dialogs.FontChooser;
import com.iver.cit.gvsig.gui.panels.ColorChooserPanel;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JCheckBox;

/**
 * @author fjp
 *
 */
public class FPanelLegendLabels extends JPanel implements ILegendPanel {

	private static final Font DEFAULT_FONT =
		  new Font("SansSerif", Font.PLAIN, 9);


	// private TOC m_TOC;
	private VectorialLegend m_Renderer;
	private ClassifiableVectorial m_lyr;
	private FSymbol m_FSymbol;

	private ColorChooserPanel m_colorChooser = new ColorChooserPanel();


	//private javax.swing.JLabel jLabel = null;
	private javax.swing.JCheckBox jCheckBox = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JComboBox jComboBoxTextField = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JComboBox jComboBoxHeightField = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JTextField jTextField = null;
	private javax.swing.JRadioButton jRadioButton = null;
	private javax.swing.JRadioButton jRadioButton1 = null;
	private FPreviewSymbol fPreviewSymbol = null;
	private javax.swing.JLabel jLabel3 = null;
	private javax.swing.JButton jButton = null;

	private Font labelFont = DEFAULT_FONT;
	//private JPanel parent;
	private javax.swing.JLabel jLabel4 = null;


    private JComboBox jComboBoxRotationField = null;


    private JLabel jLabel = null;


    private JCheckBox jCheckBoxTextOnly = null;
	/**
	 * This is the default constructor
	 */
	public FPanelLegendLabels(JPanel parent) {
		super();
		//this.parent = parent;
		initialize();
	}
	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private  void initialize() {
		jLabel = new JLabel();
		jLabel.setBounds(30, 110, 138, 18);
		jLabel.setText(PluginServices.getText(this, "rotation_field"));
		this.setLayout(null);
		this.setSize(454, 230);
		this.add(getJCheckBoxTextOnly(), null);
		this.add(jLabel, null);
		this.add(getJComboBoxRotationField(), null);
		this.add(getJCheckBox(), null);
		this.add(getJLabel1(), null);
		this.add(getJComboBoxTextField(), null);
		this.add(getJLabel2(), null);
		this.add(getJComboBoxHeightField(), null);
		this.add(getJPanel(), null);
		this.add(getFPreviewSymbol(), null);
		this.add(getJLabel3(), null);
		this.add(getJButton(), null);

		// m_colorChooser = new ColorChooserPanel();
		// m_colorChooser.setColor(Color.RED);
		m_colorChooser.setAlpha(255);
		m_colorChooser.setBounds(312, 115, 99, 34);
		m_colorChooser.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				updateControls();
			}
		});
		this.add(getJLabel4(), null);
		this.add(m_colorChooser);

	}
	public void setLayer(FLayer lyr, Legend r)
	{
		m_lyr = (ClassifiableVectorial) lyr;
		m_Renderer = (VectorialLegend)r;

		fillFieldNames();
		getJComboBoxTextField().getModel().setSelectedItem(m_Renderer.getLabelField());
        getJComboBoxHeightField().getModel().setSelectedItem(m_Renderer.getLabelHeightField());
        getJComboBoxRotationField().getModel().setSelectedItem(m_Renderer.getLabelRotationField());
		setFSymbol(r.getDefaultSymbol());

		if (m_Renderer.getLabelField() != null)
			getJCheckBox().setSelected(true);
		else
			getJCheckBox().setSelected(false);




	}
	public void setFSymbol(FSymbol sym)
	{
		if (sym == null)
		{
			m_FSymbol = new FSymbol(FShape.MULTI);
		}
		else
			m_FSymbol = sym;

		if (m_FSymbol.getFontColor()!=null){
			m_colorChooser.setColor(m_FSymbol.getFontColor());
		}
		fPreviewSymbol.setSymbol(m_FSymbol);

		getJRadioButton1().setSelected(!m_FSymbol.isFontSizeInPixels());
        getJCheckBoxTextOnly().setSelected(!m_FSymbol.isShapeVisible());
        double size = m_FSymbol.getFontSize();
        // Scale the value of the font size to the value of the height
        // and avoid too much decimal numbers
        size = ((int) (100*size / FConstant.FONT_HEIGHT_SCALE_FACTOR))/100;
		getJTextField().setText(String.valueOf(size));


	}

	private void updateControls() {
		getJComboBoxTextField().setEnabled(getJCheckBox().isSelected());
		if (getJComboBoxTextField().getSelectedIndex()!=-1){
			getJComboBoxHeightField().setEnabled(getJCheckBox().isSelected());
			getJComboBoxRotationField().setEnabled(getJCheckBox().isSelected());
		}
		getJRadioButton().setEnabled(getJCheckBox().isSelected());
		getJRadioButton1().setEnabled(getJCheckBox().isSelected());
		getJTextField().setEnabled(getJCheckBox().isSelected());
		if (getJCheckBox().isSelected())
		{
			FSymbol sym = m_FSymbol;
			sym.setFont(labelFont);
			sym.setFontColor(m_colorChooser.getColor());
			fPreviewSymbol.setSymbol(sym);
		}
	}
	public void updateValuesFromControls(VectorialLegend l) {
		if (getJCheckBox().isSelected())
		{
            m_FSymbol = l.getDefaultSymbol();
            m_FSymbol.setFont(labelFont);
			l.setLabelField((String) getJComboBoxTextField().getSelectedItem());
			l.setLabelHeightField((String) getJComboBoxHeightField().getSelectedItem());
            l.setLabelRotationField((String) getJComboBoxRotationField().getSelectedItem());
			m_FSymbol.setFontColor(m_colorChooser.getColor());
			//m_FSymbol.setSymbolType(m_Renderer.getShapeType());
			float fontSize = Float.parseFloat(getJTextField().getText());
			fontSize *= FConstant.FONT_HEIGHT_SCALE_FACTOR;
			if (!getJRadioButton().isSelected())
			{
				// meters
				/*
				 * Java scales font size by defining the cell diagonal.
				 * To obtain the right height value we need to apply a
				 * factor to the diagonal to get a right value for the
				 * height.
				 */
				m_FSymbol.setFontSize(fontSize); // Para que se pueda crear correctamente al recuperar del proyecto
				m_FSymbol.setFontSizeInPixels(false);
			}
			else
			{
				// pixels
				m_FSymbol.setFont(labelFont);
				m_FSymbol.setFont(labelFont.deriveFont(fontSize));
				m_FSymbol.setFontSize(fontSize);
				m_FSymbol.setFontSizeInPixels(true);
			}
            m_FSymbol.setShapeVisible(true);
            if (getJCheckBoxTextOnly().isSelected())
                m_FSymbol.setShapeVisible(false);

			l.setDefaultSymbol(m_FSymbol);
            // System.out.println("Color punto 3 " + m_FSymbol.getColor().toString());
		}
		else
		{
			// Para que no se dibujen las etiquetas, el campo labelField del Renderer
			// ha de ser null
			l.setLabelField(null);
		}
	}




	private void fillFieldNames() {

		SelectableDataSource rs;
		try {
			// rs = ((ProjectExtension) PluginServices.getExtension(ProjectExtension.class)).getProject().getDataSourceByLayer((FLayer) m_lyr);
			rs = ((FLyrVect)m_lyr).getRecordset();
			String[] nomFields;
            ArrayList nomNumericFields = new ArrayList();
			nomFields = new String[rs.getFieldCount()];
			for (int i = 0; i < rs.getFieldCount(); i++) {
				nomFields[i] = rs.getFieldName(i).trim();
                if ((rs.getFieldType(i) == Types.FLOAT)
                   || (rs.getFieldType(i) == Types.BIGINT)
                   || (rs.getFieldType(i) == Types.DOUBLE)
                   || (rs.getFieldType(i) == Types.INTEGER))
                    nomNumericFields.add(nomFields[i]);
			}

			DefaultComboBoxModel cM_labelField = new DefaultComboBoxModel(nomFields);
			getJComboBoxTextField().setModel(cM_labelField);
			DefaultComboBoxModel cM_HeightField = new DefaultComboBoxModel(nomNumericFields.toArray(new String[0]));
			getJComboBoxHeightField().setModel(cM_HeightField);
            DefaultComboBoxModel cM_RotationField = new DefaultComboBoxModel(nomNumericFields.toArray(new String[0]));
            getJComboBoxRotationField().setModel(cM_RotationField);

		} catch (DriverException e) {
			e.printStackTrace();
		} catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
			e.printStackTrace();
		}
	}


	/**

	 * This method initializes jCheckBox

	 *

	 * @return javax.swing.JCheckBox

	 */
	private javax.swing.JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new javax.swing.JCheckBox();
			jCheckBox.setText(PluginServices.getText(this,"Habilitar_etiquetado"));
			jCheckBox.setBounds(28, 22, 152, 23);
			jCheckBox.addItemListener(new java.awt.event.ItemListener() {

				public void itemStateChanged(java.awt.event.ItemEvent e) {
					updateControls();

				}
			});

		}
		return jCheckBox;
	}

	/**

	 * This method initializes jLabel1

	 *

	 * @return javax.swing.JLabel

	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText(PluginServices.getText(this,"Campo_de_etiquetado"));
			jLabel1.setBounds(29, 53, 139, 21);
		}
		return jLabel1;
	}

	/**

	 * This method initializes jComboBox

	 *

	 * @return javax.swing.JComboBox

	 */
	private javax.swing.JComboBox getJComboBoxTextField() {
		if (jComboBoxTextField == null) {
			jComboBoxTextField = new javax.swing.JComboBox();
			jComboBoxTextField.setBounds(175, 52, 110, 19);
			jComboBoxTextField.setEnabled(false);
			jComboBoxTextField.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (jComboBoxTextField.getSelectedIndex()!=-1){
						getJComboBoxHeightField().setEnabled(true);
						getJComboBoxRotationField().setEnabled(true);
					}else{
						getJComboBoxHeightField().setEnabled(false);
						getJComboBoxRotationField().setEnabled(false);
					}
				}
			});
		}
		return jComboBoxTextField;
	}

	/**

	 * This method initializes jLabel2

	 *

	 * @return javax.swing.JLabel

	 */
	private javax.swing.JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			jLabel2.setBounds(29, 81, 137, 21);
			jLabel2.setText(PluginServices.getText(this,"campo_altura_texto"));
			jLabel2.setVisible(true);
		}
		return jLabel2;
	}

	/**

	 * This method initializes jComboBox1

	 *

	 * @return javax.swing.JComboBox

	 */
	private javax.swing.JComboBox getJComboBoxHeightField() {
		if (jComboBoxHeightField == null) {
			jComboBoxHeightField = new javax.swing.JComboBox();
			jComboBoxHeightField.setBounds(175, 82, 110, 18);
			jComboBoxHeightField.setVisible(true);
			if (getJComboBoxTextField().getSelectedIndex()!=-1){
				jComboBoxHeightField.setEnabled(true);
			}else{
				jComboBoxHeightField.setEnabled(false);
			}

		}
		return jComboBoxHeightField;
	}

	/**

	 * This method initializes jPanel

	 *

	 * @return javax.swing.JPanel

	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.setBounds(29, 136, 258, 84);
			jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, PluginServices.getText(this,"Altura_fija_de_texto"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			ButtonGroup jButtonGroup = new ButtonGroup();
			jButtonGroup.add(getJRadioButton1());
			jButtonGroup.add(getJRadioButton());
			jPanel.add(getJRadioButton1(), null);
			jPanel.add(getJRadioButton(), null);
			jPanel.add(getJTextField(), null);
		}
		return jPanel;
	}

	/**

	 * This method initializes jTextField

	 *

	 * @return javax.swing.JTextField

	 */
	private javax.swing.JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new javax.swing.JTextField();
			jTextField.setBounds(26, 32, 76, 21);
			jTextField.setEnabled(false);
			jTextField.setText("10");
		}
		return jTextField;
	}

/**

	 * This method initializes jRadioButton

	 *

	 * @return javax.swing.JRadioButton

	 */
	private javax.swing.JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new javax.swing.JRadioButton();
			jRadioButton.setText(PluginServices.getText(this,"En_pixels"));
			jRadioButton.setBounds(145, 44, 100, 23);
			jRadioButton.setEnabled(false);
			jRadioButton.setSelected(true);
		}
		return jRadioButton;
	}

	/**

	 * This method initializes jRadioButton1

	 *

	 * @return javax.swing.JRadioButton

	 */
	private javax.swing.JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new javax.swing.JRadioButton();
			jRadioButton1.setText(PluginServices.getText(this,"En_metros"));
			jRadioButton1.setBounds(145, 16, 100, 23);
			jRadioButton1.setEnabled(false);
		}
		return jRadioButton1;
	}

	/**

	 * This method initializes fPreviewSymbol

	 *

	 * @return com.iver.cit.opensig.gui.Panels.FPreviewSymbol

	 */
	public FPreviewSymbol getFPreviewSymbol() {
		if (fPreviewSymbol == null) {
			fPreviewSymbol = new FPreviewSymbol();
			fPreviewSymbol.setBounds(311, 53, 134, 77);
		}
		return fPreviewSymbol;
	}

	/**

	 * This method initializes jLabel3

	 *

	 * @return javax.swing.JLabel

	 */
	private javax.swing.JLabel getJLabel3() {
		if (jLabel3 == null) {
			jLabel3 = new javax.swing.JLabel();
			jLabel3.setBounds(312, 28, 100, 18);
			jLabel3.setText(PluginServices.getText(this,"Previsualizacion"));
			jLabel3.setVisible(false);
		}
		return jLabel3;
	}

	/**

	 * This method initializes jButton

	 *

	 * @return javax.swing.JButton

	 */
	private javax.swing.JButton getJButton() {
		if (jButton == null) {
			jButton = new javax.swing.JButton();
			jButton.setBounds(314, 54, 111, 29);
			jButton.setText(PluginServices.getText(this,"fuente")+"...");
			jButton.addActionListener(new java.awt.event.ActionListener() {

				public void actionPerformed(java.awt.event.ActionEvent e) {
					//JButton origen = (JButton) e.getSource();
					Font newFont;

					newFont = FontChooser.showDialog("Choose Font", labelFont);

			        if (newFont == null) {
			            return;
			        }

			        labelFont = newFont;
			        updateControls();


				}
			});

		}
		return jButton;
	}

	/**

	 * This method initializes jLabel4

	 *

	 * @return javax.swing.JLabel

	 */
	private javax.swing.JLabel getJLabel4() {
		if (jLabel4 == null) {
			jLabel4 = new javax.swing.JLabel();
			jLabel4.setBounds(311, 88, 133, 23);
			jLabel4.setText(PluginServices.getText(this,"color_texto"));
		}
		return jLabel4;
	}
	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.gui.legendmanager.panels.ILegendPanel#getLegend()
	 */
	public Legend getLegend() {
		updateValuesFromControls(m_Renderer);
		return m_Renderer;
	}
    /**
     * This method initializes jComboBox1
     *
     * @return javax.swing.JComboBox
     */
    private JComboBox getJComboBoxRotationField() {
    	if (jComboBoxRotationField == null) {
    		jComboBoxRotationField = new JComboBox();
    		jComboBoxRotationField.setBounds(175, 111, 110, 19);
    		if (getJComboBoxTextField().getSelectedIndex()!=-1)
				jComboBoxRotationField.setEnabled(true);
			else
				jComboBoxRotationField.setEnabled(false);
    	}
    	return jComboBoxRotationField;
    }
    /**
     * This method initializes jCheckBox1
     *
     * @return javax.swing.JCheckBox
     */
    private JCheckBox getJCheckBoxTextOnly() {
    	if (jCheckBoxTextOnly == null) {
    		jCheckBoxTextOnly = new JCheckBox();
    		jCheckBoxTextOnly.setBounds(315, 171, 133, 22);
    		jCheckBoxTextOnly.setText(PluginServices.getText(this, "draw_text_only"));
    	}
    	return jCheckBoxTextOnly;
    }

        }  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
