/*
 * Created on 26-jun-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: MergeGeoprocessPlugin.java,v 1.4 2006/08/29 07:56:30 cesar Exp $
* $Log: MergeGeoprocessPlugin.java,v $
* Revision 1.4  2006/08/29 07:56:30  cesar
* Rename the *View* family of classes to *Window* (ie: SingletonView to SingletonWindow, ViewInfo to WindowInfo, etc)
*
* Revision 1.3  2006/08/29 07:21:09  cesar
* Rename com.iver.cit.gvsig.fmap.Fmap class to com.iver.cit.gvsig.fmap.MapContext
*
* Revision 1.2  2006/08/11 16:30:38  azabala
* *** empty log message ***
*
* Revision 1.1  2006/06/27 16:11:41  azabala
* toString() added to Plugin interface to force textual representation of geoprocess plugins
*
*
*/
package com.iver.cit.gvsig.geoprocess.impl.merge;

import java.net.URL;
import java.util.Locale;

import org.cresques.cts.IProjection;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessController;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.cit.gvsig.geoprocess.impl.merge.gui.GeoProcessingMergePanel;
import com.iver.cit.gvsig.geoprocess.impl.merge.gui.GeoProcessingMergePanel2;
import com.iver.cit.gvsig.geoprocess.manager.GeoprocessManager;
import com.iver.cit.gvsig.gui.View;

public class MergeGeoprocessPlugin implements IGeoprocessPlugin {
	
	
	private static String dataConvertPkg;
	private static String dataConvertPkgDesc;
	private static String geoprocessName;
	
	static{
		dataConvertPkg = 
			PluginServices.getText(null, "Conversion_de_datos");
		geoprocessName =
			PluginServices.getText(null, "Juntar");
		dataConvertPkgDesc =
			PluginServices.getText(null, "Conversion_de_datos_Desc");
		GeoprocessManager.
			registerPackageDescription(dataConvertPkg,
				dataConvertPkgDesc);
	}
	public IGeoprocessPanel getGeoprocessPanel() {
		View vista = (View)PluginServices.getMDIManager().getActiveWindow();
		MapContext mapContext = vista.getModel().getMapContext();
        FLayers layers = mapContext.getLayers();
        IProjection proj = mapContext.getProjection();
		GeoProcessingMergePanel2 dataSelectionPanel = 
			new GeoProcessingMergePanel2(layers);
		return dataSelectionPanel;
	}

	public URL getHtmlDescription() {
		Locale locale = Locale.getDefault();
		String localeStr = locale.getLanguage();
		String urlStr = "resources/description_" +
										localeStr +
											".html";
		return MergeGeoprocessPlugin.class.
		getResource(urlStr);
	}

	public URL getImgDescription() {
		return MergeGeoprocessPlugin.class.
		getResource("resources/mergedesc.png");
	}

	public IGeoprocessController getGpController() {
		return new MergeGeoprocessController();
	}

	public String getNamespace() {
		return dataConvertPkg + "/" + geoprocessName;
	}

	public String toString(){
		return geoprocessName;
	}

}

