/*
 * Created on 28-jun-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: XYShiftGeoprocessPlugin.java,v 1.4 2006/08/29 08:46:36 cesar Exp $
* $Log: XYShiftGeoprocessPlugin.java,v $
* Revision 1.4  2006/08/29 08:46:36  cesar
* Rename the remaining method calls (extGeoprocessingExtensions was not in my workspace)
*
* Revision 1.3  2006/08/11 17:17:55  azabala
* *** empty log message ***
*
* Revision 1.2  2006/06/29 17:58:31  azabala
* *** empty log message ***
*
* Revision 1.1  2006/06/28 18:17:21  azabala
* first version in cvs
*
*
*/
package com.iver.cit.gvsig.geoprocess.impl.xyshift;

import java.net.URL;
import java.util.Locale;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessController;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.cit.gvsig.geoprocess.impl.xyshift.gui.GeoprocessingXYShiftPanel2;
import com.iver.cit.gvsig.gui.View;

public class XYShiftGeoprocessPlugin implements IGeoprocessPlugin {

	private static String dataConvertPkg;
	private static String geoprocessName;
	
	static{
		dataConvertPkg = 
			PluginServices.getText(null, "Conversion_de_datos");
		geoprocessName =
			PluginServices.getText(null, "XYShift");
	}
	
	
	
	
	public IGeoprocessPanel getGeoprocessPanel() {
		View vista = (View)PluginServices.
		getMDIManager().
		getActiveWindow();
		FLayers layers = vista.getModel().
			getMapContext().
			getLayers();
		
		return new GeoprocessingXYShiftPanel2(layers);
	}

	public URL getHtmlDescription() {
		Locale locale = Locale.getDefault();
		String localeStr = locale.getLanguage();
		String urlStr = "resources/description_" +
										localeStr +
											".html";
		URL url = XYShiftGeoprocessPlugin.class.
		getResource(urlStr);
		return url;
	}

	public URL getImgDescription() {
		URL url = XYShiftGeoprocessPlugin.class.
			getResource("resources/xyshiftdesc.png");
		return url;
	}

	public IGeoprocessController getGpController() {
		return new XYShiftGeoprocessController();
	}

	public String getNamespace() {
		return dataConvertPkg + "/" + geoprocessName;
	}
	
	public String toString(){
		return geoprocessName;
	}

}

