package org.gvsig.georeferencing.gui.dialog;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.geom.Point2D;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableModel;

import org.gvsig.georeferencing.gui.panels.ConectorPanel;
import org.gvsig.georeferencing.gui.panels.OptionsPanel;
import org.gvsig.georeferencing.gui.panels.ZoomControlPanel;
import org.gvsig.georeferencing.gui.pointsTable.TablePointsPanel;
import org.gvsig.georeferencing.gui.pointsTable.TablePointsPanel.PointTable;
import org.gvsig.georeferencing.gui.selectPoints.DataPointPanel;
import org.gvsig.georeferencing.gui.selectPoints.SelectPointsPanel;
import org.gvsig.georeferencing.utils.GeoUtils;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.layers.IGeoUi;
import com.iver.cit.gvsig.fmap.tools.Behavior.GeoMoveBehavior;
import com.iver.cit.gvsig.fmap.tools.Behavior.GeoRedimBehavior;
import com.iver.cit.gvsig.gui.View;


public class TestGeorefDialog extends JFrame implements ComponentListener{

	private int w = 412, h = /*278;*/458;
	
	public void componentHidden(ComponentEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	public void componentMoved(ComponentEvent arg0) {
		
	}
	public void componentResized(ComponentEvent arg0) {
		System.out.println(this.getSize().getWidth()+" "+this.getSize().getHeight());
	}
	public void componentShown(ComponentEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	public TestGeorefDialog(){
		this.addComponentListener(this);
		this.setSize(w, h);
		GeoreferencingDialogTest tbp = new GeoreferencingDialogTest(this);
		this.getContentPane().add(tbp);
		this.show();
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			  //UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			  UIManager.setLookAndFeel("com.jgoodies.looks.plastic.PlasticXPLookAndFeel");
			  //UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
	    } catch( Exception e ) {
	          System.err.println( "No se puede cambiar al LookAndFeel");
	    }
		TestGeorefDialog f = new TestGeorefDialog();
	}
	
	
	class GeoreferencingDialogTest extends JPanel implements IGeoUi, ComponentListener {

		//**********************Vars**********************************
		private JPanel 						pBotones = null;  //  @jve:decl-index=0:
		private JButton 					bProcesar = null;  //  @jve:decl-index=0:
		private JButton 					bCancelar = null;  //  @jve:decl-index=0:
		private GeoRedimBehavior 			rb = null;
		private GeoMoveBehavior 			mb = null;
;
		private JFrame 						frame = null;

		private ConectorPanel				conectorPanel = null;

		private boolean 					enlarge = false;
		private int 						normalWidth = 400;
		private int 						normalHeight = 273;
		private int 						enlargeHeight = 438;
		private int 						tmpWidth = normalWidth;

		private JButton 					bAceptar = null;

		private TablePointsPanel 			tablePointsPanel = null;

		/**
		 * Panel que contiene los botones de la barra inferior
		 */
		private DialogButtons				dialogButtons = null;
		//**********************End Vars******************************


		//**********************Methods*******************************
	    /**
	     * Constructor.
	     */
	    public GeoreferencingDialogTest(JFrame f) {
	    	frame = f;
	    	initialize();
	    }

	    /**
	     * En la inicializacin de la ventana aadimos los tags de est y cargamos
	     * ls herramientas para manejar las imagenes a georeferenciar.
	     */
	    private void initialize() {
	    	
	        this.setLayout(new BorderLayout());
	        if(!enlarge){
	        	this.setPreferredSize(new java.awt.Dimension(normalWidth, normalHeight));
	        	this.setSize(new java.awt.Dimension(400,273));
	        	this.getConectorPanel().getAdjustGeorefPanel().getZoomLeft().setVisible(false);
	        	this.getConectorPanel().getAdjustGeorefPanel().getZoomRight().setVisible(false);
	        }else{
	        	this.setPreferredSize(new java.awt.Dimension(normalWidth, enlargeHeight));
	        	this.setSize(new java.awt.Dimension(normalWidth, enlargeHeight));
	        	this.getConectorPanel().getAdjustGeorefPanel().getZoomLeft().setVisible(true);
	        	this.getConectorPanel().getAdjustGeorefPanel().getZoomRight().setVisible(true);
	        }
	        this.setLocation(new java.awt.Point(0,0));

	        this.add(this.getPBotones(), BorderLayout.SOUTH);
	        this.add(this.getConectorPanel(), BorderLayout.NORTH);

	        tablePointsPanel = getConectorPanel().getDataPointsTabPanel().getTablePointsPanel();
	        tablePointsPanel.getTableControlerPanel().getBClear().addActionListener(this.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel());
	        tablePointsPanel.getTableControlerPanel().getBDelPoint().addActionListener(this.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel());

			getBInsertPointOfTablePoints().addActionListener(conectorPanel.getDataPointsTabPanel().getSelectPointsPanel());
			getBNewPointOfTablePoints().addActionListener(conectorPanel.getDataPointsTabPanel().getSelectPointsPanel());
	    }

		
		/**
		 * This method initializes jButton
		 *
		 * @return javax.swing.JButton
		 */
		public JButton getBAccept() {
			if (bAceptar == null) {
				bAceptar = new JButton();
				bAceptar.setText(PluginServices.getText(this,"aceptar"));
				bAceptar.setToolTipText(PluginServices.getText(this,"accept_tip"));
			}
			return bAceptar;
		}

		/**
		 * This method initializes bProcesar
		 *
		 * @return javax.swing.JButton
		 */
		public JButton getBProcess() {
			if (bProcesar == null) {
				bProcesar = new JButton();
				bProcesar.setText(PluginServices.getText(this,"procesar"));
				bProcesar.setToolTipText(PluginServices.getText(this,"process_tip"));
				bProcesar.setEnabled(true);
			}
			return bProcesar;
		}

		/**
		 * El botn cancelar restaura el extent con el que se carg la imagen a georreferenciar
		 * y cierra la ventana.
		 *
		 * @return javax.swing.JButton
		 */
		public JButton getBCancel() {
			if (bCancelar == null) {
				bCancelar = new JButton();
				bCancelar.setText(PluginServices.getText(this,"cancelar"));
				bCancelar.setToolTipText(PluginServices.getText(this,"cancel_tip"));
			}
			return bCancelar;
		}

		/**
		 * Asigna a las textbox el valor de pixel pasado
		 * @param x	valor x
		 * @param y	valor y
		 */
		public void setPixelText(double x, double y){
			getSelectPointsPanel().getDataPointPanel().getTX().setText(String.valueOf(x));
			getSelectPointsPanel().getDataPointPanel().getTY().setText(String.valueOf(y));
		}

		/**
		 * Asigna a las textbox el valor de coordenadas pasado
		 * @param x	valor x
		 * @param y	valor y
		 */
		public void setMapCoordText(double x, double y){
			getSelectPointsPanel().getDataPointPanel().getLongitud().setText(GeoUtils.tailDecimals(String.valueOf(x), 5));
			getSelectPointsPanel().getDataPointPanel().getLatitud().setText(GeoUtils.tailDecimals(String.valueOf(y), 5));
		}

		/**
		 * Esta funcin resetea los controles del panel de info de un punto.
		 */
		public void resetControls(boolean active){
			getConectorPanel().getDataPointsTabPanel().getTablePointsPanel().setSaveToDisk(active);
			getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().resetControls(active);
			getConectorPanel().getAdjustGeorefPanel().getZoomLeft().clear();
			getConectorPanel().getAdjustGeorefPanel().getZoomRight().clear();
			setEnabled(active);
		}

		/* (non-Javadoc)
		 * @see java.awt.event.ComponentListener#componentHidden(java.awt.event.ComponentEvent)
		 */
		public void componentHidden(ComponentEvent arg0) {
			// TODO Auto-generated method stub

		}
		/* (non-Javadoc)
		 * @see java.awt.event.ComponentListener#componentMoved(java.awt.event.ComponentEvent)
		 */
		public void componentMoved(ComponentEvent arg0) {
			// TODO Auto-generated method stub

		}
		/* (non-Javadoc)
		 * @see java.awt.event.ComponentListener#componentResized(java.awt.event.ComponentEvent)
		 */
		public void componentResized(ComponentEvent ev) {

			if(frame.getWidth() <= this.normalWidth + 10)
				frame.setSize(this.normalWidth, frame.getHeight());

			if(this.getConectorPanel().getDataPointsTabPanel().getTbPoints().getSelectedIndex() == 1){
				tmpWidth = frame.getWidth();
				this.newFrameSize(frame.getWidth(), frame.getHeight() - 10);
			}
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ComponentListener#componentShown(java.awt.event.ComponentEvent)
		 */
		public void componentShown(ComponentEvent arg0) {
			// TODO Auto-generated method stub

		}

	    /**
	     *Inicializa el tamao del dialogo
	     */
	    public void resetSize(){
	    	if(!enlarge){
	    		frame.setSize(this.normalWidth + 12, this.normalHeight + 10);
	    	}else{
	    		frame.setSize(this.normalWidth + 12, this.enlargeHeight + 10);
	    	}
	    	newFrameSize((int)Math.round(this.normalWidth / 0.98), this.normalHeight);
	    }

		/**
		 * Calculo del nuevo tamao a partir de un frame redimensionado
		 * @param w Ancho del frame
		 * @param h Alto del frame
		 */
		public void newFrameSize(int w, int h){
			int newWidth = (int)Math.round(w * 0.98);

	        this.setSize(new java.awt.Dimension(newWidth, normalHeight ));
	        this.setPreferredSize(new java.awt.Dimension(newWidth, normalHeight ));
	        this.getConectorPanel().newFrameSize(newWidth, h);
		}

		//**********************End Methods***************************

		//**********************Setters & Getters*********************
		/**
		 * Obtiene la tabla de puntos
		 */
		public PointTable getTable(){
			return this.getConectorPanel().getDataPointsTabPanel().getTablePointsPanel().getJTable();
		}

		/**
		 * Asigna un valor a una posicin de la tabla
		 * @param value Valor a asignar
		 * @param row	Fila en la que se asigna
		 * @param col	Columna en la que se asigna
		 */
		public void setTableValueAt(String value, int row, int col)throws ArrayIndexOutOfBoundsException{
			((DefaultTableModel)getTable().getTable().getModel()).setValueAt(value, row, col);
		}

		/**
		 * Asigna un valor del checkBox para una fila de la tabla
		 * @param row Fila en la que se asigna
		 */
		public void setCheckValueAt(Boolean value, int row)throws ArrayIndexOutOfBoundsException{
			((DefaultTableModel)getTable().getTable().getModel()).setValueAt(value, row, 0);
		}

		/**
		 * Obtiene el nmero de filas de la tabla
		 * @return Nmero de filas de la tabla
		 */
		public int getTableRowCount(){
			return getTable().getTable().getRowCount();
		}

		/**
		 * Aade una nueva fila a la tabla de puntos
		 */
		public void addTableNew(){
			getTable().getTableModel().addNew();
		}
		/**
		 * @return Returns the tmpWidth.
		 */
		public int getTmpWidth() {
			return tmpWidth;
		}
		/**
		 * @param tmpWidth The tmpWidth to set.
		 */
		public void setTmpWidth(int tmpWidth) {
			this.tmpWidth = tmpWidth;
		}
		/**
		 * @return Returns the enlargeHeight.
		 */
		public int getEnlargeHeight() {
			return enlargeHeight;
		}
		/**
		 * @return Returns the normalHeight.
		 */
		public int getNormalHeight() {
			return normalHeight;
		}

		/**
		 * @return Returns the normalWidth.
		 */
		public int getNormalWidth() {
			return normalWidth;
		}

		/**
		 * Asigna el valor del campo RMS
		 * @param rms Cadena que representa el RMS
		 */
		public void setRMS(String rms){
			this.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().getErrorPointPanel().getTRMS().setText(rms);
		}

		/**
		 * Asigna el valor del campo de residuo en X
		 * @param rms Cadena que representa el RMS
		 */
		public void setResX(String resX){
			this.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().getErrorPointPanel().getTResX().setText(resX);
		}

		/**
		 * Asigna el valor del campo de residuo en Y
		 * @param rms Cadena que representa el RMS
		 */
		public void setResY(String resY){
			this.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().getErrorPointPanel().getTResY().setText(resY);
		}

		/**
		 * Asigna el valor del campo RMS
		 * @param rms Cadena que representa el RMS
		 */
		public void setTotal(String total){
			this.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().getErrorPointPanel().getTTotal().setText(total);
		}

		/**
		 * Selecciona un tab del cuadro
		 * @param index
		 */
		public void setSelectedTab(int index){
			try{
				this.getConectorPanel().getDataPointsTabPanel().getTbPoints().setSelectedIndex(index);
			}catch(IllegalArgumentException ex){
				//Si peta al seleccionar un tab, pues nada.
			}
		}

		/**
		 * @param extended The extended to set.
		 */
		public void setEnlarge(boolean enlarge) {
			this.enlarge = enlarge;
			if(!enlarge){
				frame.setSize(new Dimension(this.normalWidth + 12, this.normalHeight + 10));
				//frame.setPreferredSize(new Dimension(this.normalWidth + 12, this.normalHeight + 10));
				this.setPreferredSize(new Dimension(this.normalWidth, this.normalHeight));
				this.setSize(new Dimension(this.normalWidth, this.normalHeight));
				this.getConectorPanel().setCanvasVisible(false);
			}else{
				frame.setSize(new Dimension(this.normalWidth + 12, this.enlargeHeight + 10));
				//frame.setPreferredSize(new Dimension(this.normalWidth + 12, this.enlargeHeight + 10));
				this.setPreferredSize(new Dimension(this.normalWidth, this.enlargeHeight));
				this.setSize(new Dimension(this.normalWidth, this.enlargeHeight));
				this.getConectorPanel().setCanvasVisible(true);
			}
			frame.pack();
		}

		/**
		 * @return Returns the extended.
		 */
		public boolean isEnlarge() {
			return enlarge;
		}

		/**
	     * Obtiene el panel conector
	     * @return
	     */
	    public ConectorPanel getConectorPanel() {
		    if (conectorPanel == null) {
		    	conectorPanel = new ConectorPanel();
		    }

		    return conectorPanel;
	    }

		/**
		 * This method initializes jPanel
		 *
		 * @return javax.swing.JPanel
		 */
		private JPanel getPBotones() {
			if (pBotones == null) {
				FlowLayout flowLayout1 = new FlowLayout();
				pBotones = new JPanel();
				pBotones.setLayout(flowLayout1);
				flowLayout1.setHgap(2);
				flowLayout1.setAlignment(java.awt.FlowLayout.RIGHT);
				pBotones.add(getDialogButtons(), null);
				pBotones.add(getBProcess(), null);
				pBotones.add(getBAccept(), null);
				pBotones.add(getBCancel(), null);
			}
			return pBotones;
		}

		/**
		 * @return Returns the GeoRedimBehavior.
		 */
		public GeoRedimBehavior getGeoRedimBehavior() {
			return rb;
		}

		/**
		 * @param rb The GeoRedimBehavior to set.
		 */
		public void setGeoRedimBehavior(GeoRedimBehavior rb) {
			this.rb = rb;
		}

		/**
		 * @return Returns the GeoMoveBehavior
		 */
		public GeoMoveBehavior getGeoMoveBehavior() {
			return mb;
		}

		/**
		 * @param mb The GeoMoveBehavior to set.
		 */
		public void setGeoMoveBehavior(GeoMoveBehavior mb) {
			this.mb = mb;
		}


		/**
		 * Obtiene el punto de la lista que ha sido seleccionado
		 * @return
		 */
		public int getSelectedPoint(){
			return getConectorPanel().getDataPointsTabPanel().
				getSelectPointsPanel().getTableControlerPanel().getSelectedIndex();
		}

		/**
		 * Obtiene el control de la mini imagen que tiene los botones a la izquierda
		 * @return ZoomControlPanel
		 */
		public ZoomControlPanel getZoomControlLeft(){
			return this.getConectorPanel().getAdjustGeorefPanel().getZoomLeft();
		}

		/**
		 * Obtiene el control de la mini imagen que tiene los botones a la derecha
		 * @return ZoomControlPanel
		 */
		public ZoomControlPanel getZoomControlRight(){
			return this.getConectorPanel().getAdjustGeorefPanel().getZoomRight();
		}

		/**
		 * Obtiene el panel de seleccin de puntos
		 * @return Panel de seleccin de puntos
		 */
		public SelectPointsPanel getSelectPointsPanel(){
			return this.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel();
		}

		/**
		 * Obtiene el panel de opciones
		 * @return OptionPanel
		 */
		public OptionsPanel getOptionsPanel(){
			return getConectorPanel().getAdjustGeorefPanel().getOptionsPanel();
		}

	    /**
	     * Activa o desactiva este panel y todos los que lo componen
	     * @param enabled variable booleana para la activacin y/o desactivacin
	     */
	    public void setEnabled(boolean enabled){
	    	conectorPanel.getDataPointsTabPanel().getSelectPointsPanel().setEnabled(enabled);
	    	conectorPanel.getAdjustGeorefPanel().setEnabled(enabled);
	    }

	    /**
	     *
	     */
	    public ViewPort getLeftInitViewport(ViewPort vp, Point2D center, ViewPort initVp, double zoom){
	    	return getZoomControlLeft().getCanvas().initViewPort(vp, center, initVp, zoom);
	    }

		/**
		 * Obtiene el botn de activar/desactivar la insercin de punto del panel del control de
		 * tabla
		 * @return JToggleButton
		 */
		public JToggleButton getBInsertPointOfTablePoints(){
			return tablePointsPanel.getPTablePanelButtons().getBInsertPoint();
		}

		/**
		 * Obtiene el botn de activar/desactivar la insercin de punto del panel del control de
		 * tabla
		 * @return JToggleButton
		 */
		public JButton getBNewPointOfTablePoints(){
			return tablePointsPanel.getTableControlerPanel().getBNew();
		}

		/**
		 * This method initializes jPanel
		 *
		 * @return javax.swing.JPanel
		 */
		public DialogButtons getDialogButtons() {
			if (dialogButtons == null) {
				dialogButtons = new DialogButtons();
			}
			return dialogButtons;
		}

		/**
		 * Activa/desactiva los botones de la barra correspondientes al salvado
		 * de datos a disco.
		 * @param active true activa los controles y false los desactiva.
		 */
		public void setEnableSaveButtons(boolean active){
			getDialogButtons().getBSave().setEnabled(active);
			getDialogButtons().getBExportToCSV().setEnabled(active);
		}
		//**********************End Setters & Getters*****************

		public void updateData(int nPunto, Point2D pixel, Point2D map, View view) {
			// TODO Auto-generated method stub
			
		}

		public void savePoints() throws Exception {
			// TODO Auto-generated method stub
			
		}

		public boolean isErrorCSV() {
			// TODO Auto-generated method stub
			return false;
		}

		public double[][] getErrors() {
			// TODO Auto-generated method stub
			return null;
		}

		public void close() {
			// TODO Auto-generated method stub
			
		}

	 } 


}
