package org.gvsig.georeferencing.utils;

import junit.framework.TestCase;

import org.cresques.px.Extent;

/**
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class ZoomStackTest extends TestCase{
	private static final int 		NEXTENTS = 3;
	private StackZoom 				stack = null;
	Extent[] 						ext = new Extent[NEXTENTS];
	Extent							newExt = new Extent(4, 4, 4, 4);
	
	public void setUp() {
		System.out.println("ZoomStackTest running...");
		stack = new StackZoom();
		for(int i=0;i<NEXTENTS;i++){
			ext[i] = new Extent(i, i ,i ,i);
			if(i == 0)
				stack.setInitExtent(ext[i], true);
			else
				stack.setZoom(ext[i]);
		}
	}
	
	public void testStack(){
		//Top apunta al ltimo elemento y selectElem tambien
		assertEquals(stack.getStackSize(), NEXTENTS - 1);
		assertEquals(stack.getSelectElem(), NEXTENTS - 1);
		
		//Vaciamos la pila y volvemos a llenarla 
		assertNull(stack.getNextZoom());
		assertEquals(stack.getLastZoom(), ext[1]);
		assertEquals(stack.getLastZoom(), ext[0]);
		assertNull(stack.getLastZoom());
		assertEquals(stack.getNextZoom(), ext[1]);
		assertEquals(stack.getNextZoom(), ext[2]);
		assertNull(stack.getNextZoom());
		
		//Eliminamos un elemento  e insertamos otro
		assertEquals(stack.getLastZoom(), ext[1]);
		
		stack.setZoom(newExt);
		
		assertNull(stack.getNextZoom());
		assertEquals(stack.getLastZoom(), ext[1]);
		assertEquals(stack.getNextZoom(), newExt);
	}
}
