/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */

package org.gvsig.rasterTools.brightnessContrast.ui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.cresques.filter.IRasterOperationsRegistrablePanels;
import org.cresques.filter.IStackManager;
import org.cresques.filter.RasterFilterStackManager;
import org.cresques.io.GeoRasterFile;
import org.cresques.ui.raster.FilterRasterDialogPanel;
import org.gvsig.rasterTools.brightnessContrast.filter.BrightnessContrastStackManager;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.gui.panels.IRasterPropertiesRegistrable;
import com.iver.cit.gvsig.gui.panels.PropertiesRasterDialog;
import com.iver.cit.gvsig.gui.toc.FLyrRasterAdjustPropertiesTocMenuEntry;


/**
 * Panel para los controles de brillo, contrase y realce.
 * @author Miguel Angel Querol Carratal <querol_mig@gva.es>
 *
 */
public class EnhancedBrightnessContrastPanel extends JPanel implements ActionListener, 
																	MouseListener,
																	KeyListener,
																	IRasterPropertiesRegistrable,
																	IRasterOperationsRegistrablePanels{

	private JPanel pBrightCont = null;
	private JPanel pEnhanced = null;
	private LabelSliderText lstBrightness = null;
	private LabelSliderText lstContrast = null;
	private JPanel pBCCheck = null;
	private JPanel pBCSlider = null;
	private JPanel jPanel1 = null;
	private JCheckBox cBrightC = null;
	private JLabel lBrightC = null;
	private JPanel pEnCheck = null;
	private JPanel pEnSlider = null;
	private JCheckBox cEnhanced = null;
	private JPanel pDelInt = null;
	private JCheckBox jCheckBox = null;
	
	private BrightnessContrastStackManager bcManager = null;
	private JCheckBox jCheckBox1 = null;
	private JLabel lpreview = null;
	public FLyrRaster layer = null;
	public PropertiesRasterDialog propertiesRasterDialog = null;
	public RasterFilterStackManager rasterStackManager = null;
	public JLabel lLineal = null;
	public JLabel lRemove = null;
	public CheckSliderText cstEnhanced = null;
	
	/**
	 * This is the default constructor
	 */
	public EnhancedBrightnessContrastPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.insets = new java.awt.Insets(0,4,0,4);
		gridBagConstraints3.gridy = 0;
		gridBagConstraints3.gridx = 1;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.insets = new java.awt.Insets(0,4,0,4);
		gridBagConstraints2.gridy = 0;
		gridBagConstraints2.gridx = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(445, 239);
		this.setPreferredSize(new java.awt.Dimension(445,239));
		this.add(getPBrightCont(), gridBagConstraints2);
		this.add(getPEnhanced(), gridBagConstraints3);
		
		this.getCBrightC().addActionListener(this);
		this.getCEnhanced().addActionListener(this);
		this.getLabelSliderText().getJSlider().addMouseListener(this);
		this.getLabelSliderText1().getJSlider().addMouseListener(this);
		this.setTranslation();
		this.getLabelSliderText().getJTextField().addActionListener(this);
		this.getLabelSliderText1().getJTextField().addActionListener(this);
	}

	public void setTranslation(){
		this.lLineal.setText(PluginServices.getText(this, "lineal_directo"));
		this.lRemove.setText(PluginServices.getText(this, "eliminar_extremos"));
		this.cstEnhanced.setName(PluginServices.getText(this, "recorte_colas")+" ( % )");
		this.lBrightC.setText(PluginServices.getText(this, "activar"));
		this.lstBrightness.setName(PluginServices.getText(this, "brillo"));
		this.lstContrast.setName(PluginServices.getText(this, "contraste"));
		this.lpreview.setText(PluginServices.getText(this, "previsualizacion"));
	}
	
	
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPBrightCont() {
		if (pBrightCont == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.insets = new java.awt.Insets(4,0,8,0);
			gridBagConstraints4.gridy = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new java.awt.Insets(0,8,4,8);
			gridBagConstraints.gridy = 0;
			pBrightCont = new JPanel();
			pBrightCont.setLayout(new GridBagLayout());
			pBrightCont.setPreferredSize(new java.awt.Dimension(210,223));
			pBrightCont.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1), (PluginServices.getText(this, "brillo_y_contraste")), javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, java.awt.Color.black));
			pBrightCont.add(getPBCCheck(), gridBagConstraints);
			pBrightCont.add(getPBCSlider(), gridBagConstraints4);
		}
		return pBrightCont;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPEnhanced() {
		if (pEnhanced == null) {
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 0;
			gridBagConstraints12.insets = new java.awt.Insets(4,4,59,4);
			gridBagConstraints12.gridy = 1;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.insets = new java.awt.Insets(0,8,4,8);
			gridBagConstraints11.gridy = 0;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 0;
			pEnhanced = new JPanel();
			pEnhanced.setLayout(new GridBagLayout());
			pEnhanced.setPreferredSize(new java.awt.Dimension(210,223));
			pEnhanced.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1), (PluginServices.getText(this, "realce")), javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, java.awt.Color.black));
			pEnhanced.add(getPEnCheck(), gridBagConstraints11);
			pEnhanced.add(getPEnSlider(), gridBagConstraints12);
		}
		return pEnhanced;
	}

	/**
	 * inicializa el conponente LabelSliderText
	 */
	public LabelSliderText getLabelSliderText(){
		if(lstBrightness == null){
			lstBrightness = new LabelSliderText();
			lstBrightness.setName("Brillo");
			lstBrightness.setSliderRange(-255,255);
			lstBrightness.setSliderValue(0);
		}
		return lstBrightness;
	}

	/**
	 * inicializa el conponente LabelSliderText
	 */
	public LabelSliderText getLabelSliderText1(){
		if (lstContrast == null){
			lstContrast = new LabelSliderText();
			lstContrast.setName("Contraste");
			lstContrast.setPreferredSize(new java.awt.Dimension(180,45));
			lstContrast.setSliderRange(-255,255);
			lstContrast.setSliderValue(0);
		}
		return lstContrast;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPBCCheck() {
		if (pBCCheck == null) {
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 1;
			gridBagConstraints9.gridy = 0;
			lBrightC = new JLabel();
			lBrightC.setText("Activar");
			lBrightC.setPreferredSize(new java.awt.Dimension(160,15));
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 0;
			gridBagConstraints8.gridy = 0;
			pBCCheck = new JPanel();
			pBCCheck.setLayout(new GridBagLayout());
			pBCCheck.setPreferredSize(new java.awt.Dimension(182,25));
			pBCCheck.add(getCBrightC(), gridBagConstraints8);
			pBCCheck.add(lBrightC, gridBagConstraints9);
		}
		return pBCCheck;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPBCSlider() {
		if (pBCSlider == null) {
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.insets = new java.awt.Insets(0,0,2,0);
			gridBagConstraints7.gridy = 0;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.insets = new java.awt.Insets(10,0,8,0);
			gridBagConstraints6.gridy = 2;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints5.gridy = 1;
			pBCSlider = new JPanel();
			pBCSlider.setLayout(new GridBagLayout());
			pBCSlider.setPreferredSize(new java.awt.Dimension(188,150));
			pBCSlider.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pBCSlider.add(getLabelSliderText(), gridBagConstraints7);
			pBCSlider.add(getLabelSliderText1(), gridBagConstraints5);
			pBCSlider.add(getJPanel1(), gridBagConstraints6);
			this.setBCControlEnabled(false);
		}
		return pBCSlider;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.gridx = 1;
			gridBagConstraints19.gridy = 0;
			lpreview = new JLabel();
			lpreview.setText("Previsualizacion");
			lpreview.setPreferredSize(new java.awt.Dimension(150,15));
			lpreview.setSize(new java.awt.Dimension(160,15));
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 0;
			gridBagConstraints10.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints10.gridy = 0;
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.setPreferredSize(new java.awt.Dimension(180,25));
			jPanel1.add(getJCheckBox1(), gridBagConstraints10);
			jPanel1.add(lpreview, gridBagConstraints19);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getCBrightC() {
		if (cBrightC == null) {
			cBrightC = new JCheckBox();
		}
		return cBrightC;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPEnCheck() {
		if (pEnCheck == null) {
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints14.gridy = 0;
			gridBagConstraints14.gridx = 1;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints13.gridy = 0;
			gridBagConstraints13.gridx = 0;
			lLineal = new JLabel();
			lLineal.setText("Lineal Directo");
			lLineal.setPreferredSize(new java.awt.Dimension(160,15));
			pEnCheck = new JPanel();
			pEnCheck.setLayout(new GridBagLayout());
			pEnCheck.setPreferredSize(new java.awt.Dimension(182,25));
			pEnCheck.add(getCEnhanced(), gridBagConstraints13);
			pEnCheck.add(lLineal, gridBagConstraints14);
		}
		return pEnCheck;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPEnSlider() {
		if (pEnSlider == null) {
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.insets = new java.awt.Insets(2,0,0,0);
			gridBagConstraints18.gridy = 1;
			gridBagConstraints18.gridx = 0;
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.insets = new java.awt.Insets(0,0,2,0);
			gridBagConstraints15.gridy = 0;
			gridBagConstraints15.gridx = 0;
			pEnSlider = new JPanel();
			pEnSlider.setLayout(new GridBagLayout());
			pEnSlider.setPreferredSize(new java.awt.Dimension(188,100));
			pEnSlider.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pEnSlider.add(getPDelInt(), gridBagConstraints15);
			pEnSlider.add(getCheckSliderText(), gridBagConstraints18);
			this.setEControlEnabled(false);
		}
		return pEnSlider;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getCEnhanced() {
		if (cEnhanced == null) {
			cEnhanced = new JCheckBox();
		}
		return cEnhanced;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPDelInt() {
		if (pDelInt == null) {
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridx = 1;
			gridBagConstraints17.gridy = 0;
			lRemove = new JLabel();
			lRemove.setText("Eliminar Extremos");
			lRemove.setPreferredSize(new java.awt.Dimension(150,15));
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints16.gridy = 0;
			gridBagConstraints16.gridx = 0;
			pDelInt = new JPanel();
			pDelInt.setLayout(new GridBagLayout());
			pDelInt.setPreferredSize(new java.awt.Dimension(180,25));
			pDelInt.add(getJCheckBox(), gridBagConstraints16);
			pDelInt.add(lRemove, gridBagConstraints17);
		}
		return pDelInt;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
		}
		return jCheckBox;
	}
	
	/**
	 * inicializa el conponente CheckSliderText
	 */
	public CheckSliderText getCheckSliderText(){
		String rcName = "Recorte de colas"; 
		if (cstEnhanced == null){
			cstEnhanced = new CheckSliderText();
			cstEnhanced.setName(rcName);
			cstEnhanced.setSliderValue(0);
			cstEnhanced.setSliderRange(0,50);
			cstEnhanced.setDecimal(true);
			cstEnhanced.setTextValue("0.0");
			
		}
		return cstEnhanced;
	}

	/**
	 * Habilita o dehabilita el panel de brillo y contraste
	 * @param active
	 */
	public void setBCControlEnabled(boolean active){
		this.lstBrightness.setControlEnabled(active);
		this.lstContrast.setControlEnabled(active);
		this.getJCheckBox1().setEnabled(active);
		this.lpreview.setEnabled(active);
	}
	
	/**
	 * Habilita o dehabilita el panel de realce
	 * @param active
	 */
	public void setEControlEnabled(boolean active){
		this.jCheckBox.setEnabled(active);
		this.lRemove.setEnabled(active);
		this.cstEnhanced.setControlEnabled(active);		
	}
	
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.getCBrightC()){
			this.setBCControlEnabled(this.getCBrightC().isSelected());
		}
		if(e.getSource() == cEnhanced){
			this.setEControlEnabled(this.getCEnhanced().isSelected());
		}
		if((e.getSource() == this.getLabelSliderText().getJTextField()) ||
			(e.getSource() == this.getLabelSliderText1().getJTextField())){
			
			if(this.getJCheckBox1().isSelected()){		
				this.layer = propertiesRasterDialog.getFLyrRaster();
				this.rasterStackManager = propertiesRasterDialog.getStackManager();
				processBrightnessContrastPanel(this.rasterStackManager, this.propertiesRasterDialog, this.layer);
			}
	
		}
	} 
	
	/**
	 * Asigna a este panel un stack manager
	 * @param p
	 */
	public void setBrightnessContrastStackManager (BrightnessContrastStackManager p){
		this.bcManager = p;
	}
	
	/**
	 * Aade los filtros de frillo y contraste a la pila de filtros con los valores
	 * introducidos en el panel. 
	 * @param stackManager
	 * @param propsDialog
	 * @param layer
	 */
	private void processBrightnessContrastPanel(RasterFilterStackManager stackManager, PropertiesRasterDialog propsDialog, FLyrRaster layer){
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)((FilterRasterDialogPanel)propsDialog.getContentPane()).getPanelByClassName("EnhancedBrightnessContrastPanel");
		// Si est activo el panel de brillo y contraste tomamos los valores y cargamos un filtro de 
		// brillo y contraste
		
		if(ebcPanel.getCBrightC().isSelected()){
			int incrBrillo = (int)Math.round(Double.valueOf(ebcPanel.lstBrightness.getTextValue()).doubleValue());
			int incrContraste = (int)Math.round(Double.valueOf(ebcPanel.lstContrast.getTextValue()).doubleValue());
			bcManager.addBrightnessFilter(incrBrillo);
			bcManager.addContrastFilter(incrContraste);
		}else{
			stackManager.removeFilter(bcManager.brightness);
			stackManager.removeFilter(bcManager.contrast);
		}	
		layer.getMapContext().invalidate();
	}
	
	
	//-------------------------------------------------------------------------------
	
	/**
	 * Mtodo que se ejecuta desde el PropertiesRasterDialog para todos los paneles insertados
	 * cuando se pulsa el botn aceptar.
	 */
	public void actionPerformed(RasterFilterStackManager stackManager, PropertiesRasterDialog propsDialog, FLyrRaster fLayer) {
		
		processBrightnessContrastPanel(stackManager, propsDialog, fLayer);
		
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)((FilterRasterDialogPanel)propsDialog.getContentPane()).getPanelByClassName("EnhancedBrightnessContrastPanel");
		
		//Filtro de realce lineal seleccionado
		if(ebcPanel.getCEnhanced().isSelected()){
			if((ebcPanel.getJCheckBox().isSelected()) && (!ebcPanel.getCheckSliderText().getJCheckBox().isSelected()))
				stackManager.addEnhancedFilter(true, fLayer.getSource().getFiles()[0].getName());
			else
				stackManager.addEnhancedFilter(false, fLayer.getSource().getFiles()[0].getName());
				
			//Recorte de colas seleccionado
			if(ebcPanel.getCheckSliderText().getJCheckBox().isSelected()){
				stackManager.removeFilter(stackManager.getTypeFilter("computeminmax"));
				double recorte = Double.parseDouble(ebcPanel.getCheckSliderText().getTextValue())/100;
				if(ebcPanel.getJCheckBox().isSelected())
					stackManager.addTailFilter(recorte, 0D, true);
				else
					stackManager.addTailFilter(recorte, 0D, false);
			}else{
				stackManager.removeFilter(stackManager.getTypeFilter("tail"));
				stackManager.addComputeMinMaxFilter();
			}
			
		}
		// Sin filtro lineal seleccionado
		if(!ebcPanel.getCEnhanced().isSelected()){
			stackManager.removeFilter(stackManager.getTypeFilter("computeminmax"));
			stackManager.removeFilter(stackManager.getTypeFilter("tail"));
			stackManager.removeFilter(stackManager.getTypeFilter("enhanced"));
		}
		fLayer.getMapContext().invalidate();
		
	}

	public void addTabPanel(FLyrRasterAdjustPropertiesTocMenuEntry menu) {
		// TODO Auto-generated method stub
		
	}

	public void setStackManager(RasterFilterStackManager stackManager) {
		// TODO Auto-generated method stub
		
	}
	
	public IStackManager getStackManager() {
		// TODO Auto-generated method stub
		return bcManager;
	}

	
	//----------------------------------------------------------------------------------
	
	
	public void removeFile(String file) {
		// TODO Auto-generated method stub
		
	}
	
	public void addFiles(GeoRasterFile[] files) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
		}
		return jCheckBox1;
	}
	
	public void setPropertiesDialog(PropertiesRasterDialog prop){
		this.propertiesRasterDialog = prop;
	}
	

	//********************************************************************
	//***********************EVENTOS DE RATN*****************************
	
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * Listener que actua cuando el check "previsualizar" est activado
	 * y aplica los filtros con los valores seleccionados cuando soltamos
	 * el botn del ratn al seleccionar valor en el slider.
	 */
	public void mouseReleased(MouseEvent e) {
		if (((e.getSource() == this.lstBrightness.getJSlider()) || 
				(e.getSource() == this.lstContrast.getJSlider())) &&
				(this.getJCheckBox1().isSelected() == true)){
			this.layer = propertiesRasterDialog.getFLyrRaster();
			this.rasterStackManager = propertiesRasterDialog.getStackManager();
			processBrightnessContrastPanel(this.rasterStackManager, this.propertiesRasterDialog, this.layer);
		}
		
	}

	public void keyPressed(KeyEvent e) {
		if(e.getSource() == this.getCheckSliderText().getJTextField()){
			this.getCheckSliderText().getJSlider().setValue((int) Math.round(Double.valueOf(this.getCheckSliderText().getTextValue()).doubleValue()));
		}
	}
	
	public void keyReleased(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void keyTyped(KeyEvent e) {
		
	}
}

