package com.iver.cit.gvsig.wfs;

import java.io.File;
import java.io.IOException;
import java.io.StringWriter;
import java.net.ConnectException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.naming.OperationNotSupportedException;

import junit.framework.TestCase;

import org.geotools.data.DataStore;
import org.geotools.data.DefaultQuery;
import org.geotools.data.FeatureReader;
import org.geotools.data.Query;
import org.geotools.data.Transaction;
import org.geotools.data.wfs.WFSDataStoreFactory;
import org.geotools.feature.AttributeType;
import org.geotools.feature.AttributeTypeFactory;
import org.geotools.feature.FeatureType;
import org.geotools.feature.IllegalAttributeException;
import org.geotools.xml.DocumentWriter;
import org.geotools.xml.schema.Element;
import org.geotools.xml.wfs.WFSSchema;
import org.gvsig.remoteClient.wfs.WFSAttribute;
import org.gvsig.remoteClient.wfs.WFSClient;
import org.gvsig.remoteClient.wfs.WFSStatus;
import org.xml.sax.SAXException;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.IFeatureIterator;
import com.iver.cit.gvsig.fmap.drivers.geotools.WFSFeatureLayer;
import com.iver.cit.gvsig.fmap.drivers.geotools.WFSGetFeatureParser;
import com.iver.cit.gvsig.fmap.layers.WFSLayerNode;

import junit.framework.TestCase;
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSTest.java,v 1.1 2006/06/14 07:56:36 jorpiell Exp $
 * $Log: WFSTest.java,v $
 * Revision 1.1  2006/06/14 07:56:36  jorpiell
 * Test de parseo de getfeature
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSTest extends TestCase {
	private String sUrl;
	private String feature;
	private String fields;
	private String fieldTypes;
	
	protected void setUp() throws Exception {
//		sUrl = "http://sercartlin:8080/geoserver/wfs?REQUEST=getCapabilities&SERVICE=WFS";
//		feature = "topp:states";
//		fields="tipo,municipio,the_geom";	
//		sUrl = "http://simon.coput.gva.es:2000/cgi-bin/mapserv483?map=/etc/mapserver/interno/wfs.map&REQUEST=getCapabilities&SERVICE=WFS";
//		feature = "cit:hidro_lin_300k";
//		fields="color,codigo";
		sUrl = "http://www2.dmsolutions.ca/cgi-bin/mswfs_gmap";
		feature = "grid";
		fields = "msGeometry,F_CODE";
		fieldTypes = "gml:GeometryPropertyType,string";
		

	}	
	
	
	public void testWFS() throws Exception{
		WFSClient remoteServicesClient = new WFSClient(sUrl);
		File file = remoteServicesClient.getFeature(getStatus());
		System.out.println("Fin descarga");
		WFSFeatureLayer fl = new WFSFeatureLayer(file,
				getNode(),
				getStatus());
		IFeatureIterator iterator = fl.getIterator();		
		System.out.println("Fin parseo");
		int i=0;
		while (iterator.hasNext()){
			IFeature feat = iterator.next();
//			IGeometry geom = feat.getGeometry();
			i++;
		}
		System.out.println("Encontradas " + i + " Features");
	}
	
	private WFSStatus getStatus(){
		WFSStatus status = new WFSStatus(feature);
		status.setFields(fields.split(","));
		status.setUserName("");
		status.setPassword("");
		status.setTimeout(100000);
		status.setBuffer(1000);
		return status;
	}
	
	private WFSLayerNode[] getNode(){
		WFSLayerNode[] layers = new WFSLayerNode[1];
		layers[0] = new WFSLayerNode();
		layers[0].setName(feature);
		String[] vfields = fields.split(",");
		String[] vfieldTypes = fieldTypes.split(",");
		for (int i=0 ; i<vfields.length ; i++){
			WFSAttribute attribute = new WFSAttribute();
			attribute.setName(vfields[i]);
			attribute.setType(vfieldTypes[i]);
			layers[0].getFields().add(attribute);
		}
		return layers;
	}
}
