package com.iver.cit.gvsig.gui.panels;

import java.awt.Rectangle;
import java.text.NumberFormat;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import org.gvsig.remoteClient.wfs.WFSStatus;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.WFSLayerNode;
import com.iver.utiles.StringUtilities;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSOptionsPanel.java,v 1.9 2006/09/05 14:25:05 jorpiell Exp $
 * $Log: WFSOptionsPanel.java,v $
 * Revision 1.9  2006/09/05 14:25:05  jorpiell
 * Eliminado el nombre de usuario y la contrasea del panel de opciones
 *
 * Revision 1.8  2006/07/21 11:50:31  jaume
 * improved appearance
 *
 * Revision 1.7  2006/06/22 06:54:14  jorpiell
 * Se ha desabilitado el cuadro de dilogo del sistema de referencia
 *
 * Revision 1.6  2006/06/21 12:35:45  jorpiell
 * Se ha aadido la ventana de propiedades. Esto implica aadir listeners por todos los paneles. Adems no se muestra la geomatra en la lista de atributos y se muestran nicamnete los que se van a descargar
 *
 * Revision 1.5  2006/06/15 07:50:58  jorpiell
 * Aadida la funcionalidad de reproyectar y hechos algunos cambios en la interfaz
 *
 * Revision 1.4  2006/06/01 15:40:50  jorpiell
 * Se ha capturado una excepcin que saltaba al ejecutar la extensin en igls provocada por el signo "," que aparece en lo nmeros (en castellano ".").
 *
 * Revision 1.3  2006/05/23 08:09:39  jorpiell
 * Se ha cambiado la forma en la que se leian los valores seleccionados en los paneles y se ha cambiado el comportamiento de los botones
 *
 * Revision 1.2  2006/05/19 12:57:08  jorpiell
 * Modificados algunos paneles
 *
 * Revision 1.1  2006/04/20 16:38:24  jorpiell
 * Ahora mismo ya se puede hacer un getCapabilities y un getDescribeType de la capa seleccionada para ver los atributos a dibujar. Queda implementar el panel de opciones y hacer el getFeature().
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSOptionsPanel extends JPanel{

	private JPanel credentialsPanel = null;
	private JLabel usernameLabel = null;
	private JTextField usernameText = null;
	private JLabel passwordLabel = null;
	private JPasswordField passwordText = null;
	private JPanel connectionParamsPanel = null;
	private JLabel timeoutLabel = null;
	private JFormattedTextField bufferText = null;
	private JLabel bufferLabel = null;
	private JFormattedTextField timeOutText = null;
	private JPanel formatPanel = null;
	private JLabel srsLabel = null;
	private JTextField srsText = null;
	private WFSParamsPanel parent = null;
	/**
	 * This method initializes
	 *
	 */
	public WFSOptionsPanel(WFSParamsPanel parent) {
		super();
		this.parent = parent;
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 */
	private void initialize() {
		this.setLayout(null);
		this.setBounds(10, 5, 481, 427);
		this.add(getConnectionParamsPanel(), null);
		this.add(getFormatPanel(), null);

	}
	

	/**
	 * This method initializes usernameText
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getUsernameText() {
		if (usernameText == null) {
			usernameText = new JTextField();
			usernameText.setBounds(new java.awt.Rectangle(100,25,200,20));
			usernameText.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					parent.isApplicable(true);
				}
			});
		}
		return usernameText;
	}

	/**
	 * This method initializes passwordText
	 *
	 * @return javax.swing.JTextField
	 */
	private JPasswordField getPasswordText() {
		if (passwordText == null) {
			passwordText = new JPasswordField();
			passwordText.setBounds(new java.awt.Rectangle(100,50,200,20));
			passwordText.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					parent.isApplicable(true);
				}
			});
		}
		return passwordText;
	}

	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getConnectionParamsPanel() {
		if (connectionParamsPanel == null) {
			bufferLabel = new JLabel();
			bufferLabel.setBounds(new Rectangle(10, 25, 85, 16));
			bufferLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
			bufferLabel.setText(PluginServices.getText(this, "buffer"));
			bufferLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			bufferLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			timeoutLabel = new JLabel();
			timeoutLabel.setBounds(new Rectangle(10, 50, 85, 16));
			timeoutLabel.setText(PluginServices.getText(this, "timeout"));
			timeoutLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			connectionParamsPanel = new JPanel();
			connectionParamsPanel.setLayout(null);
			connectionParamsPanel.setBounds(new java.awt.Rectangle(7,65,485,80));
			connectionParamsPanel.setBorder(BorderFactory.createTitledBorder(null, PluginServices.getText(this, "conection"), TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));
			connectionParamsPanel.add(timeoutLabel, null);
			connectionParamsPanel.add(getBufferText(), null);
			connectionParamsPanel.add(bufferLabel, null);
			connectionParamsPanel.add(getTimeOutText(), null);
		}
		return connectionParamsPanel;
	}

	/**
	 * This method initializes jTextField
	 *
	 * @return javax.swing.JTextField
	 */
	private JFormattedTextField getBufferText() {
		if (bufferText == null) {
			bufferText = new JFormattedTextField(NumberFormat.getIntegerInstance());
			bufferText.setValue(new Integer(1000));
			bufferText.setBounds(new Rectangle(100, 25, 70, 20));
			bufferText.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					parent.isApplicable(true);
				}
			});
		}
		return bufferText;
	}

	/**
	 * This method initializes jTextField1
	 *
	 * @return javax.swing.JTextField
	 */
	private JFormattedTextField getTimeOutText() {
		if (timeOutText == null) {
			timeOutText = new JFormattedTextField(NumberFormat.getIntegerInstance());
			timeOutText.setValue(new Integer(10000));
			timeOutText.setBounds(new Rectangle(100, 50, 70, 20));
			timeOutText.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					parent.isApplicable(true);
				}
			});
		}
		return timeOutText;
	}

	/**
	/**
	 *
	 * @return the username
	 */
	public String getUserName(){
		return getUsernameText().getText();
	}

	/**
	 *
	 * @return the password
	 */
	public String getPassword(){
		return getPasswordText().getText();
	}

	/**
	 *
	 * @return the buffer
	 */
	public int getBuffer(){
		try{
			String buffer = StringUtilities.replace(getBufferText().getText(),".","");
			buffer = StringUtilities.replace(buffer,",","");
			return Integer.parseInt(buffer);
		}catch(NumberFormatException e){
			return 10000;
		}
	}

	/**
	 *
	 * @return the timeout
	 */
	public int getTimeout(){
		try{
			String timeOut = StringUtilities.replace(getTimeOutText().getText(),".","");
			timeOut = StringUtilities.replace(timeOut,",","");
			return Integer.parseInt(timeOut);
		}catch(NumberFormatException e){
			return 10000;
		}
	}

	/**
	 * This method initializes formatPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getFormatPanel() {
		if (formatPanel == null) {
			srsLabel = new JLabel();
			srsLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
			srsLabel.setText(PluginServices.getText(this, "srs"));
			srsLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			srsLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			srsLabel.setBounds(new java.awt.Rectangle(10, 25, 85, 16));
			formatPanel = new JPanel();
			formatPanel.setLayout(null);
			formatPanel.setBorder(BorderFactory.createTitledBorder(null, PluginServices.getText(this, "srs"), TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));
			formatPanel.setBounds(new java.awt.Rectangle(7,5,485,55));
			formatPanel.add(srsLabel, null);
			formatPanel.add(getSrsText(), null);
		}
		return formatPanel;
	}

	/**
	 * This method initializes srsText
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getSrsText() {
		if (srsText == null) {
			srsText = new JTextField();
			srsText.setBounds(new java.awt.Rectangle(100, 25, 70, 20));
			srsText.setEnabled(false);
			srsText.setEditable(false);
		}
		return srsText;
	}

	/**
	 * Refresh the panel
	 * @param feature
	 */
	public void refresh(WFSLayerNode feature) {
		Vector srs = feature.getSrs();
		if (srs.size() > 0){
			getSrsText().setText((String)srs.get(0));
		}
	}

	public void setStatus(WFSStatus status) {
		getBufferText().setText(String.valueOf(status.getBuffer()));
		getTimeOutText().setText(String.valueOf(status.getTimeout()));
		getUsernameText().setText(status.getUserName());
		getPasswordText().setText(status.getPassword());
	}
}
