/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.io;

import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;

import org.cresques.px.Extent;

import java.awt.Image;

import java.net.URL;

import javax.imageio.ImageIO;


/**
 * @author Luis W. Sevilla (sevilla_lui@gva.es)
 */
public class MapServerInputStream extends GeoRasterFile {
    int width;
    int height;
    protected MapServerClient mapServer = null;

    public MapServerInputStream(IProjection proj, String name) {
        super(proj, name);
    }

    public MapServerInputStream(IProjection proj, MapServerClient server) {
        super(proj, server.getName());
        mapServer = server;
        extent = mapServer.getViewExtent();
    }

    public GeoFile load() {
        System.out.println("mapServer size = (" + width + "," + height +
                           ")" /*+
        "\n inc=("+file.cellIncrementX+","+file.cellIncrementY+")\n"+
        " datum='"+file.datum+"', proyeccion='"+file.projection+"'"*/                   );

        return this;
    }

    /* (non-Javadoc)
     * @see org.cresques.io.GeoRasterFile#close()
     */
    public void close() {
        // TODO Auto-generated method stub
    }

    public void setExtent(Extent e) {
        extent = e;
    }

    public void setSize(int w, int h) {
        width = w;
        height = h;
    }

    public int getWidth() {
        return width;
    }

    public int getHeight() {
        return height;
    }

    /* (non-Javadoc)
     * @see org.cresques.io.GeoRasterFile#reProject(org.cresques.cts.ICoordTrans)
     */
    public void reProject(ICoordTrans rp) {
        // TODO Auto-generated method stub
    }

    public void setView(Extent e) {
        /**/ mapServer.setView((long) e.getMin().getX(), (long) e.getMax().getY(),
                            (long) e.getMax().getX(), (long) e.getMin().getY());
    }

    public Extent getView() {
        return mapServer.getViewExtent();
    }

    /* (non-Javadoc)
     * @see org.cresques.io.GeoRasterFile#updateImage(int, int, org.cresques.cts.ICoordTrans)
     */
    public Image updateImage(int width, int height, ICoordTrans rp) {
        Image image = null;
        int line;
        int[] pRGBArray = null;

        if (mapServer == null) {
            return image;
        }

        try {
            /**/ mapServer.setViewSize(width, height);
            System.out.println("Querying mapServer: " + mapServer.getUrl());
            image = ImageIO.read(new URL(mapServer.getUrl()));
        } catch (Exception e) {
            e.printStackTrace();
        }

        return image; //.getScaledInstance(width, height, Image.SCALE_FAST);
    }

    /* (non-Javadoc)
     * @see org.cresques.io.GeoRasterFile#updateImage(int, int, org.cresques.cts.ICoordTrans, java.awt.Image, int)
     */
    public Image updateImage(int width, int height, ICoordTrans rp, Image img,
                             int flags) {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see org.cresques.io.GeoRasterFile#updateImage(int, int, org.cresques.cts.ICoordTrans, java.awt.Image, int)
     */
    public Image updateImage(int width, int height, ICoordTrans rp, Image img,
                             int origBand, int destBand) {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see org.cresques.io.GeoRasterFile#getData(int, int, int)
     */
    public Object getData(int x, int y, int band) {
        // TODO Auto-generated method stub
        return null;
    }

    public int getBlockSize() {
        return 0;
    }

    public byte[] getWindow(int ulX, int ulY, int sizeX, int sizeY, int band) {
        return null;
    }
    
    public void setExtentTransform(double originX, double originY, double w, double f, double psX, double psY) {}
}
