/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.rendering;

import com.iver.cit.gvsig.fmap.core.v02.FSymbol;


/**
 * Interfaz que ofrece los mtodos para clasificar la Leyenda por intervalos.
 */
public interface IntervalLegend extends ClassifiedLegend {
    /**
     * Establece el smbolo asociado al intervalo
     *
     * @param i Intervalo.
     * @param value Smbolo.
     */
    void addSymbol(Object i, FSymbol value);

    /**
     * Elimina el smbolo a partir del objeto que se pasa como parmetro.
     *
     * @param i Objeto que hace de clave para eliminar el smbolo.
     */
    void delSymbol(Object i);

    /**
     * Cambia el intervalo index-simo del array de intervalos
     *
     * @param index ndice.
     * @param newInterval nuevo intervalo.
     */
    void changeInterval(int index, IInterval newInterval);
}
