/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.rendering;

import com.hardcode.gdbms.engine.values.Value;

import com.iver.cit.gvsig.fmap.core.v02.FSymbol;


/**
 * Interfaz de leyenda de valores nicos.
 */
public interface UniqueValueLegend extends ClassifiedLegend {
    /**
     * Establece el smbolo para el valor que se pasa como parmetro
     *
     * @param id ndice.
     * @param symbol smbolo.
     */
    void setValueSymbolByID(int id, FSymbol symbol);

    /**
     * Aade un smbolo.
     *
     * @param key clave.
     * @param symbol smbolo.
     */
    void addSymbol(Object key, FSymbol symbol);

    /**
     * Elimina un smbolo a partir del objeto que se pasa como parmetro.
     *
     * @param key clave.
     */
    void delSymbol(Object key);

    /**
     * Devuelve un smbolo a partir del ID. Mira en el m_ArrayKeys  el elemento
     * ID, y con esa clave recupera el FSymbol por valor
     *
     * @param key ID.
     *
     * @return smbolo que corresponde a ese ID.
     */

    // public FSymbol getSymbolByID(int ID);

    /**
     * Devuelve un smbolo a partir de su clave.
     *
     * @param key ID.
     *
     * @return smbolo que corresponde a ese ID.
     */
    public FSymbol getSymbolByValue(Value key);
}
