package org.gvsig.remoteClient.wfs;

import java.awt.geom.Rectangle2D;
import java.net.URL;

import org.gvsig.remoteClient.RemoteClientStatus;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSStatus.java,v 1.3 2006/06/14 07:54:18 jorpiell Exp $
 * $Log: WFSStatus.java,v $
 * Revision 1.3  2006/06/14 07:54:18  jorpiell
 * Se parsea el online resource que antes se ignoraba
 *
 * Revision 1.2  2006/05/23 13:23:13  jorpiell
 * Se ha cambiado el final del bucle de parseado y se tiene en cuenta el online resource
 *
 * Revision 1.1  2006/04/19 12:51:35  jorpiell
 * Aadidas algunas de las clases del servicio WFS
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSStatus extends RemoteClientStatus{
	private String featureName = null;
	private String[] fields = null;
	private String userName = null;
	private String password = null;
	private String onlineResource = null;
	private Rectangle2D	bBox = null;
	private int timeout = 10000;
	private int buffer = 100;		
	
	public WFSStatus(String featureName){
		this.featureName = featureName;
	}

	/**
	 * @return Returns the bBox.
	 */
	public Rectangle2D getBBox() {
		return bBox;
	}


	/**
	 * @param box The bBox to set.
	 */
	public void setBBox(Rectangle2D box) {
		bBox = box;
	}


	/**
	 * @return Returns the buffer.
	 */
	public int getBuffer() {
		return buffer;
	}


	/**
	 * @param buffer The buffer to set.
	 */
	public void setBuffer(int buffer) {
		this.buffer = buffer;
	}


	/**
	 * @return Returns the featureName.
	 */
	public String getFeatureName() {
		return featureName;
	}


	/**
	 * @param featureName The featureName to set.
	 */
	public void setFeatureName(String featureName) {
		this.featureName = featureName;
	}


	/**
	 * @return Returns the fields.
	 */
	public String[] getFields() {
		return fields;
	}


	/**
	 * @param fields The fields to set.
	 */
	public void setFields(String[] fields) {
		this.fields = fields;
	}


	/**
	 * @return Returns the password.
	 */
	public String getPassword() {
		return password;
	}


	/**
	 * @param password The password to set.
	 */
	public void setPassword(String password) {
		this.password = password;
	}


	/**
	 * @return Returns the timeout.
	 */
	public int getTimeout() {
		return timeout;
	}


	/**
	 * @param timeout The timeout to set.
	 */
	public void setTimeout(int timeout) {
		this.timeout = timeout;
	}


	/**
	 * @return Returns the userName.
	 */
	public String getUserName() {
		return userName;
	}


	/**
	 * @param userName The userName to set.
	 */
	public void setUserName(String userName) {
		this.userName = userName;
	}


	public String getOnlineResource() {
		return onlineResource;
	}
	

	public void setOnlineResource(String url) {
		onlineResource = url;
	}
}