/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/**
 * 
 */
package org.gvsig.gui.beans.comboBoxItemsSeeker;

import java.util.Vector;

import javax.swing.DefaultComboBoxModel;

import org.apache.log4j.Logger;

/** VERSIN EN DESARROLLO
 *  COMENTAR Y REVISAR
 * Se consideran los datos que contiene DefaultComboBoxModel como los que se tomarn para devolver datos a no ser que sea para actualizar la lista
 *    de la vista, que en cuyo caso se tendr en cuenta la configuracin del comportamiento y atributos internos.
 * 
 * @author Pablo Piqueras Bartolom (p_queras@hotmail.com)
 */
public abstract class AbstractDefaultComboBoxItemsSeekerConfigurableModel extends DefaultComboBoxModel{
	// INNER MODEL STRUCTURES
	protected Object itemsSearchesShow[];
	// END INNER MODEL STRUCTURES
	
	// TRACE - DEBUG
	protected Logger logger = Logger.getLogger(AbstractDefaultComboBoxItemsSeekerConfigurableModel.class.getClass());
	// END TRACE - DEBUG
		
	// CONTANTS FOR CONFIGURE THE BEHAVIOR
	public static final int MAINTAIN_ORIGINAL_POSITION_START = 0;
	public static final int ORDERED_START = 1;
	public static final int DISORDERED_START = 2;

	public static final int MAINTAIN_ORIGINAL_POSITION_ALL_ITEMS_SEARCH = 3;
	public static final int ORDERED_ALL_ITEMS_SEARCH = 4;
	public static final int DISORDERED_ALL_ITEMS_SEARCH = 5;
	public static final int MAINTAIN_ORIGINAL_POSITION_DYNAMIC_SEARCH = 6;
	public static final int ORDERED_DYNAMIC_SEARCH = 7;
	public static final int DISORDERED_DYNAMIC_SEARCH = 8;

	// END CONTANTS FOR CONFIGURE THE BEHAVIOR
	
	// CONFIGURATION FLAGS (Voy a Cambiar algunas!!!!)
	protected int startBehavior;
	protected int searchBehavior;
	protected boolean caseSensitive;
	// END FLAGS	//		this.maintainPositionItems = true;		
//	this.alphanumericSortedSearches = true;
//	this.allAlphanumericSorted = false;

	protected int stateAllItems;
	protected final int STATE_DEFAULT = 10;
	protected final int STATE_ITEMS_ARE_ORDERED = 11;
	protected final int STATE_ITEMS_ARE_DISORDERED = 12;
	
	
	// OTHER FLAGS
	protected boolean startView;
	protected boolean dynamicSearches;
	protected boolean dynamicStart;
	protected boolean dynamicSearchDone;
	protected boolean itemsInTheArray;
	// END OTHER FLAGS

	// ATTRIBUTES FOR DYNAMIC CASES
	protected String writtenText;
	// END ATTRIBUTES FOR DYNAMIC CASES
	
	/**
	 * Default Constructor without parameters.
	 * Constructs an empty ComboBoxItemsSeekerDynamicModel object.          
	 */
	public AbstractDefaultComboBoxItemsSeekerConfigurableModel() {
		super();
		this.initialize();
	}
	
	/**
	 * Default Constructor with an array of objects as parameter.
	 * Constructs a ComboBoxItemsSeekerDynamicModel object initialized with an array of objects.
	 * @throws Exception 
	 */
	public AbstractDefaultComboBoxItemsSeekerConfigurableModel(Object[] items) {		
		super(items);
		this.initialize();
		
//		if (!this.itemsShowed.addAll(Arrays.asList(items)))
//			throw new Exception();
	}

	/**
	 * Default Constructor with a vector as parameter.
	 * Constructs a ComboBoxItemsSeekerDynamicModel object initialized with a vector.
	 * @throws Exception 
	 */
	public AbstractDefaultComboBoxItemsSeekerConfigurableModel(Vector objects) {
		super(objects);
		this.initialize();
		
//		if (!this.itemsShowed.addAll(objects))
//			throw new Exception();
	}
	
	/**
	 * This method set the start values of inner attributes and creates the necessary inner objects
	 */
	protected void initialize() {

		
//		this.currentString = "";
		this.writtenText = "";
		this.setDefaultBehaviorFlagsConfiguration();
		this.startView = true;
//		this.allItemsAreSorted = false;
//		this.allItemsAreDisordered = false;
		this.stateAllItems = STATE_DEFAULT;
		this.dynamicSearches = false;
		this.dynamicStart = false;
		this.dynamicSearchDone = false; 
		this.itemsInTheArray = false;
	
//		this.itemsShowed = new TreeSet();
	}
	
	/**
	 * Method that sets the default values of the behavior flags
	 */
	protected void setDefaultBehaviorFlagsConfiguration() {
		// Set the default values of the flags
//		this.maintainPositionItems = true;		
//		this.alphanumericSortedSearches = true;
//		this.allAlphanumericSorted = false;
		this.startBehavior = MAINTAIN_ORIGINAL_POSITION_START;
		this.searchBehavior = ORDERED_DYNAMIC_SEARCH;
		this.caseSensitive = false;
//		this.showAllItems = true; //false;	
	}
	
	/** A BORRAR
	 * @param currentString The currentString to set.
	 */
//	public void setCurrentString(String currentString) {
//		this.currentString = currentString;
//		Vector v = new Vector();		
//		
//		//Refrescar el modelo		
//		for (int i=0 ; i<allObjects.size() ; i++){
//			String obj = allObjects.get(i).toString();
//			if (currentString.equals("")){
//				v.add(allObjects.get(i));
//			}else if (obj.indexOf(currentString) == 0){
//				v.add(allObjects.get(i));
//			}
//		}
//		orderedObjects = v;
//	}
	
	
	////// METHODS FOR THE BEHAVIOR FLAGS  //////
	
	/**
	 * This method tests the configuration of the flags and returns true or false if its ok or not with the
	 *   logical behavior of this component
	 * 
	 * @return boolean True if the configuration of the flags is oks, false if not
	 */
	public boolean testFlagsConfigurationOK() {
//		if ((maintainPositionItems == allAlphanumericSorted) && (maintainPositionItems == true))
//			return false;
//		
//		if ((maintainPositionItems == false) && (allAlphanumericSorted == true) && (alphanumericSortedSearches == false))
//			return false;
		
		if ((this.startBehavior < 0) || (this.startBehavior > 2))
			return false;
		
		if ((this.searchBehavior < 3) || (this.searchBehavior > 8))
			return false;
		
//		if ((showAllItems == true) && (maintainPositionItems == false))
//			return false;
		
		return true;
	}

	public int getStartBehavior() {
		return this.startBehavior;
	}
	
	public void setStartBehavior(int start_Behavior) {
		this.startBehavior = start_Behavior;		
	}

	public int getSearchBehavior() {
		return this.searchBehavior;
	}

	/**
	 * 
	 * @param search_Behavior
	 */
	public void setSearchBehavior(int search_Behavior) {
		this.searchBehavior = search_Behavior;
		
		if ((this.searchBehavior > 5) && (this.searchBehavior < 9))
			this.dynamicSearches = true;
		else
			this.dynamicSearches = false;
	}

	/**
	 * Gets the flag of the configuration of the caseSensitive flag of this component 
	 * (true -> discriminates capital letters from small letters ,false -> don't discriminates capital letters from small letters)
	 * 
	 * @return boolean The value of the flag
	 */
	public boolean isCaseSensitive() {
		return caseSensitive;
	}
	
	/**
	 * Sets the flag of the configuration of the caseSensitive flag of this component 
	 * (true -> discriminates capital letters from small letters ,false -> don't discriminates capital letters from small letters)
	 * 
	 * @param boolean The value of the flag
	 */
	public void setCaseSensitive(boolean case_Sensitive) {
		this.caseSensitive = case_Sensitive;
	}
	


	////// END METHODS FOR THE BEHAVIOR FLAGS //////
	
	////// REIMPLEMENTATION OF SOME METHODS OF "DefaultComboBoxModel" TO ADAPT THE BEHAVIOR OF THIS MODEL //////	
	
	/*
	 *  (non-Javadoc)
	 * @see javax.swing.DefaultComboBoxModel#getSize()
	 */
	public abstract int getSize();
	

	/*
	 *  (non-Javadoc)
	 * @see javax.swing.ListModel#getElementAt(int)
	 */
	public abstract Object getElementAt(int index);

	/* HACER?
	 *  (non-Javadoc)
	 * @see javax.swing.DefaultComboBoxModel#getIndexOf(java.lang.Object)
	 */
	public abstract int getIndexOf(Object anObject);		
    /*
     *  (non-Javadoc)
     * @see javax.swing.ComboBoxModel#getSelectedItem()
     */
	public Object getSelectedItem() {
		return super.getSelectedItem();
	}
	
	/*
	 *  (non-Javadoc)
	 * @see javax.swing.MutableComboBoxModel#addElement(java.lang.Object)
	 */
	public abstract void addElement(Object anObject);
	
	/*
	 *  (non-Javadoc)
	 * @see javax.swing.MutableComboBoxModel#insertElementAt(java.lang.Object, int)
	 */
	public abstract void insertElementAt(Object anObject, int index);    
	/*
	 *  (non-Javadoc)
	 * @see javax.swing.DefaultComboBoxModel#removeAllElements()
	 */
	public abstract void removeAllElements();
    
	/*
	 *  (non-Javadoc)
	 * @see javax.swing.MutableComboBoxModel#removeElement(java.lang.Object)
	 */
	public abstract void removeElement(Object anObject);
	
	/*
	 *  (non-Javadoc)
	 * @see javax.swing.MutableComboBoxModel#removeElementAt(int)
	 */
	public abstract void removeElementAt(int index);
	
	/**
	 * Returns the size of the parent of this component: 'ComboBoxModel'
	 * 
	 * @return int The size of the parent
	 */
	public int getParentSize() {
		return super.getSize();
	}
	
	protected void addElementToParent(Object anObject) {
		super.addElement(anObject);
	}
	
	protected Object getParentElementAt(int index) {
		return super.getElementAt(index);
	}
	
	protected int getParentIndexOf(Object anObject) {
		return super.getIndexOf(anObject);
	}
	
	protected void insertToParentElementAt(Object anObject, int index) {
		super.insertElementAt(anObject, index);
	}
	
	protected void removeAllElementsOfParent() {
		super.removeAllElements();
	}
	
	protected void removeParentElement(Object anObject) {
		super.removeElement(anObject);
	}
	
	/**
	 * @param index
	 */
	protected void removeParentElementAt(int index) {
		// TODO Auto-generated method stub
		super.removeElementAt(index);
	}
	
	////// END REIMPLEMENTATION OF SOME METHODS OF "DefaultComboBoxModel" TO ADAPT THE BEHAVIOR OF THIS MODEL //////	
	
	////// OTHER METHODS //////
	
	// This operation will be slowly -> solucin sera mantener una copia aqu del padre (pero requiere ms memoria para una operacin poco utilizada)
	public abstract Vector getParentAllData();
	
	public Object getFirstItemAdded() {
	
		return super.getElementAt(0);
	}
	
	/**
	 * 
	 */
	public void setWrittenText(String text) {
		this.writtenText = text;
		this.reset();
	}
	
	/**
	 * 
	 * @param flagValue
	 */
	public void setStartViewFlag(boolean flagValue) {
		this.startView = flagValue;
		this.reset();
	}
	
	public boolean isStartViewFlag() {
		return this.startView;
	}
	
	protected void reset() {
		if (this.stateAllItems != STATE_DEFAULT)
		{
			this.stateAllItems = STATE_DEFAULT;
			this.dynamicSearchDone = false; 
			this.itemsInTheArray = false;
		}
	}
	
	public boolean isDynamicSearch() {
		return this.dynamicSearches;
	}
		
	protected abstract void seekDynamicItems(); 
	
	public boolean nowItemsAreDisordered() {
		if (this.startView)
		{
			if (getStartBehavior() == DISORDERED_START)
				return true;
		}
		else
		{
			if ((getSearchBehavior() == DISORDERED_DYNAMIC_SEARCH) || (getSearchBehavior() == DISORDERED_ALL_ITEMS_SEARCH))
				return true;
		}
		
		return false;
	}
	
	
	protected abstract void getDynamicItemsSearch(BinaryRankOfItemsSearch search, int lowIndex, int hightIndex);	
	
	
	protected abstract void setItemsCopyToArray();
	
	/**
	 * This method gets the items of this component disordered and store them on a array
	 */
	protected abstract void disorderItemsCopy();
	
	////// END OTHER METHODS //////

	protected class BinaryRankOfItemsSearch {
		private int lowIndex;
		private int hightIndex;
		private int lowIndexSubSet2; // Only used for not caseSensitive case
		private int hightIndexSubSet2; // Only used for not caseSensitive case
		
//		private String text;
	
		public BinaryRankOfItemsSearch () {
			// By default -> no search has been made
			this.lowIndex = -1;
			this.hightIndex = -1;
			this.lowIndexSubSet2 = -1;
			this.hightIndexSubSet2 = -1;
//			this.text = textStart;
		}
	
		public void binaryRankSearch() {
//			boolean finish = false;
			boolean continueInLoop = true;
			int mediumIndex;
			int maxNumberOfIterations = (int) MathExtensionReduced.log2(itemsSearchesShow.length);
			logger.debug("Number of iterations: " + maxNumberOfIterations);
			int currentIteration = 0;
				
			this.lowIndex = 0;
			this.hightIndex = itemsSearchesShow.length - 1;
			
			// First -> Find the first item that match its start (This is an iterational version of the binarySearch algorithm)
			if (isCaseSensitive())
			{
				// Iterational version of a binary search of the first item that it start matches with a text
				while (continueInLoop)
				{
					// If can't continue searching (item hasn't been found) (With this condition we avoid infinites loops)
					if (currentIteration > maxNumberOfIterations)
					{
//						this.lowIndex = 0;
//						this.hightIndex = itemsSearchesShow.length -1;
						this.lowIndex = this.hightIndex + 1; // Force not show any item after
						continueInLoop = false;							
					}
					else
					{
						mediumIndex = (int) Math.floor((this.lowIndex + this.hightIndex) / 2);
											
						// If has find the first item that mathes its start
						if (itemsSearchesShow[mediumIndex].toString().startsWith(writtenText))
						{
							this.lowIndex = this.hightIndex = mediumIndex;
							continueInLoop = false;
						}
						else
						{
							// Reduce the rank of search
							if (itemsSearchesShow[mediumIndex].toString().compareTo(writtenText) > 0)
								this.hightIndex = mediumIndex - 1;							
							else
								this.lowIndex = mediumIndex + 1;
							
//							 If can't continue searching (item hasn't been found)
							if (this.lowIndex > this.hightIndex)
							{
//								this.lowIndex = 0;
//								this.hightIndex = itemsSearchesShow.length -1;

								continueInLoop = false;							
							}
							else
								currentIteration ++;
						}
					}
				}
				
				logger.debug("BINARY-SEARCH: Low-Index: " + this.lowIndex + "; Hight-Index: " + this.hightIndex);
			}
			else
			{	
				// Elements are ordered in this order -> First UpperCases, Second Simbols, Third LowerCases (left -> right character priority)
				
				// Get The first SubSet
				// Iterational version of a binary search of the first item that its start matches with a text
				while (continueInLoop)
				{
					// If can't continue searching (item hasn't been found) (With this condition we avoid infinites loops)
					if (currentIteration > maxNumberOfIterations)
					{
						this.lowIndex = this.hightIndex + 1; // Force not show any item after
						continueInLoop = false;							
					}
					else
					{
						mediumIndex = (int) Math.floor((this.lowIndex + this.hightIndex) / 2);
											
						// If has find the first item that mathes its start
						if (itemsSearchesShow[mediumIndex].toString().toUpperCase().startsWith(writtenText.toUpperCase()))
//						if (itemsSearchesShow[mediumIndex].toString().toLowerCase().startsWith(writtenText.toLowerCase()))
						{
							this.lowIndex = this.hightIndex = mediumIndex;
							continueInLoop = false;
						}
						else
						{
							// Reduce the rank of search
							if (itemsSearchesShow[mediumIndex].toString().compareToIgnoreCase(writtenText) > 0) // da problemas
//							if (itemsSearchesShow[mediumIndex].toString().toLowerCase().compareTo(writtenText.toLowerCase()) > 0) // da problemas
//							if (itemsSearchesShow[mediumIndex].toString().toUpperCase().compareTo(writtenText.toUpperCase()) > 0) // da problemas
								this.hightIndex = mediumIndex - 1;							
							else
								this.lowIndex = mediumIndex + 1;
							
//							 If can't continue searching (item hasn't been found)
							if (this.lowIndex > this.hightIndex)
							{
//								this.lowIndex = 0;
//								this.hightIndex = itemsSearchesShow.length -1;

								continueInLoop = false;							
							}
							else
								currentIteration ++;
						}
					}
				}
			
				logger.debug("BINARY-SEARCH-FirstSubSet: Low-Index: " + this.lowIndex + "; Hight-Index: " + this.hightIndex);
				
				
				//		EL SEGUNDO SUBCONJUNTO DEBE BUSCAR SLO LAS PALABRAS/ITEMS QUE EMPIECEN POR MAYSCULAS!!
				// Get The second SubSet
				continueInLoop = true;
				currentIteration = 0;
				this.lowIndexSubSet2 = 0;
				this.hightIndexSubSet2 = itemsSearchesShow.length - 1;

				// Iterational version of a binary search of the first item that its start matches with a text
				// In this case tries to find a subset of items that ther string value start with uppercase
				while (continueInLoop)
				{
					// If can't continue searching (item hasn't been found) (With this condition we avoid infinites loops)
					if (currentIteration > maxNumberOfIterations)
					{
						this.lowIndexSubSet2 = this.hightIndexSubSet2 + 1; // Force not show any item after
						continueInLoop = false;							
					}
					else
					{
						mediumIndex = (int) Math.floor((this.lowIndexSubSet2 + this.hightIndexSubSet2) / 2);
											
						// If has find the first item that mathes its start
						if (itemsSearchesShow[mediumIndex].toString().toUpperCase().startsWith(writtenText.toUpperCase()))
//						if (itemsSearchesShow[mediumIndex].toString().toLowerCase().startsWith(writtenText.toLowerCase()))
						{
							this.lowIndexSubSet2 = this.hightIndexSubSet2 = mediumIndex;
							continueInLoop = false;
						}
						else
						{
							// Reduce the rank of search
//							if (itemsSearchesShow[mediumIndex].toString().compareTo(writtenText) > 0) // da problemas
							if (itemsSearchesShow[mediumIndex].toString().compareTo(writtenText.toUpperCase()) > 0) // da problemas
	//						if (itemsSearchesShow[mediumIndex].toString().toUpperCase().compareTo(writtenText.toUpperCase()) > 0) // da problemas
								this.hightIndexSubSet2 = mediumIndex - 1;							
							else
								this.lowIndexSubSet2 = mediumIndex + 1;
							
	//						 If can't continue searching (item hasn't been found)
							if (this.lowIndexSubSet2 > this.hightIndexSubSet2)
							{
	//							this.lowIndex = 0;
	//							this.hightIndex = itemsSearchesShow.length -1;
	
								continueInLoop = false;							
							}
							else
								currentIteration ++;
						}
					}
				}
				
				logger.debug("BINARY-SEARCH-SecondSubSet: Low-Index: " + this.lowIndexSubSet2 + "; Hight-Index: " + this.hightIndexSubSet2);
				
				// Force not do another search of rank of items
				if ((lowIndex == lowIndexSubSet2) && (hightIndex == hightIndexSubSet2))
					lowIndexSubSet2 = hightIndexSubSet2 + 1;
			}
					
			
			// Second -> if indexes are the same -> search the rank of items (items are ordered in the 'itemsSearchesShow' array
			if (this.lowIndex == this.hightIndex)
			{				
				
				if (isCaseSensitive())
				{
					// Seek down
					this.lowIndex --;
					if (this.lowIndex > -1)
						continueInLoop = true;
					else
						continueInLoop = false;

					while (continueInLoop)
					{
//						if (itemsSearchesShow[this.lowIndex].toString().compareTo(writtenText) < 0) // No s si esta comparacin o la de startsWith
						if (!itemsSearchesShow[this.lowIndex].toString().startsWith(writtenText))
							continueInLoop = false; // Because items are sorted in the array 'itemsSearchesShow'
						else
						{
							this.lowIndex --;
							if (this.lowIndex < 0) // Because the item at the 0 position has already been verified
								continueInLoop = false;
						}
					}
					this.lowIndex++;
					
					// Seek up
					this.hightIndex ++;
					if (this.hightIndex < itemsSearchesShow.length)
						continueInLoop = true;
					else
						continueInLoop = false;
					
					while (continueInLoop)
					{
//						if (itemsSearchesShow[this.hightIndex].toString().compareTo(writtenText) > 0) // No s si esta comparacin o la de startsWith
						if (!itemsSearchesShow[this.hightIndex].toString().startsWith(writtenText)) 
							continueInLoop = false; // Because items are sorted in the array 'itemsSearchesShow'
						else
						{
							this.hightIndex ++;
							if (this.hightIndex >= itemsSearchesShow.length) // Because the item at the 0 position has already been verified
								continueInLoop = false;
						}
					}
					this.hightIndex --;				
				}
				else
				{
					// Seek down
					this.lowIndex --;
					if (this.lowIndex > -1)
						continueInLoop = true;
					else
						continueInLoop = false;

					while (continueInLoop)
					{
						//if (itemsSearchesShow[this.lowIndex].toString().toUpperCase().compareTo(writtenText.toUpperCase()) > 0) // No s si esta comparacin o la de startsWith
						if (!itemsSearchesShow[this.lowIndex].toString().toUpperCase().startsWith(writtenText.toUpperCase()))
							continueInLoop = false; // Because items are sorted in the array 'itemsSearchesShow'
						else
						{
							this.lowIndex --;
							if (this.lowIndex < 0) // Because the item at the 0 position has already been verified
								continueInLoop = false;
						}
					}
					this.lowIndex++;
					
					// Seek up
					this.hightIndex ++;
					if (this.hightIndex < itemsSearchesShow.length)
						continueInLoop = true;
					else
						continueInLoop = false;
					
					while (continueInLoop)
					{
						//if (itemsSearchesShow[this.hightIndex].toString().toUpperCase().compareTo(writtenText.toUpperCase()) < 0) // No s si esta comparacin o la de startsWith
						if (!itemsSearchesShow[this.hightIndex].toString().toUpperCase().startsWith(writtenText.toUpperCase()))
							continueInLoop = false; // Because items are sorted in the array 'itemsSearchesShow'
						else
						{
							this.hightIndex ++;
							if (this.hightIndex >= itemsSearchesShow.length) // Because the item at the 0 position has already been verified
								continueInLoop = false;
						}
					}
					this.hightIndex --;					
				}				
			}
			logger.debug("Low-Index: " + this.lowIndex + "; Hight-Index: " + this.hightIndex);
			
			

			// This executed only for cases which isn't enabled case sensitive
			if (!isCaseSensitive())
			{
				// Second -> if indexes are the same -> search the rank of items (items are ordered in the 'itemsSearchesShow' array
				if (this.lowIndexSubSet2 == this.hightIndexSubSet2)
				{				

					// Seek down
					this.lowIndexSubSet2 --;
					if (this.lowIndexSubSet2 > -1)
						continueInLoop = true;
					else
						continueInLoop = false;

					while (continueInLoop)
					{
						//if (itemsSearchesShow[this.lowIndex].toString().toUpperCase().compareTo(writtenText.toUpperCase()) > 0) // No s si esta comparacin o la de startsWith
						if (!itemsSearchesShow[this.lowIndexSubSet2].toString().toUpperCase().startsWith(writtenText.toUpperCase()))
							continueInLoop = false; // Because items are sorted in the array 'itemsSearchesShow'
						else
						{
							this.lowIndexSubSet2 --;
							if (this.lowIndexSubSet2 < 0) // Because the item at the 0 position has already been verified
								continueInLoop = false;
						}
					}
					this.lowIndexSubSet2++;
					
					// Seek up
					this.hightIndexSubSet2 ++;
					if (this.hightIndexSubSet2 < itemsSearchesShow.length)
						continueInLoop = true;
					else
						continueInLoop = false;
					
					while (continueInLoop)
					{
						//if (itemsSearchesShow[this.hightIndex].toString().toUpperCase().compareTo(writtenText.toUpperCase()) < 0) // No s si esta comparacin o la de startsWith
						if (!itemsSearchesShow[this.hightIndexSubSet2].toString().toUpperCase().startsWith(writtenText.toUpperCase()))
							continueInLoop = false; // Because items are sorted in the array 'itemsSearchesShow'
						else
						{
							this.hightIndexSubSet2 ++;
							if (this.hightIndexSubSet2 >= itemsSearchesShow.length) // Because the item at the 0 position has already been verified
								continueInLoop = false;
						}
					}
					this.hightIndexSubSet2 --;
				}				
				
				logger.debug("Low-Index: " + this.lowIndexSubSet2 + "; Hight-Index: " + this.hightIndexSubSet2);
			}
		}
	
		public int getLowIndex() {
			return this.lowIndex;
		}
		
		public int getHightIndex() {
			return this.hightIndex;
		}

		// Only for not casesetsitive cases
		public int getLowIndexSecondSubSet() {
			return this.lowIndexSubSet2;
		}
		
		// Only for not casesetsitive cases
		public int getHightIndexSecondSubSet() {
			return this.hightIndexSubSet2;
		}
	}


}
